<?php

/**
 * Fichier edit_categories.php pour gérer des documents
 *
 * Copyright 2010-2014 Pascal Fautrero, Bouguin Régis
 *
 * beta-testers : Didier Blanqui, Régis Bouguin
 *
 * This file is part of MesDocuments, a plugin for GEPI.
 *
 * GEPI is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * MesDocuments is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with GEPI; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

$titre_page = "Mes Documents";
$affiche_connexion = 'yes';
$niveau_arbo = "2";


// ===============================================================
//
//                  IMPORTATION DES FONCTIONS
//
// ===============================================================
include("./includes.php");

// ===============================================================
//
//                  INITIALISATION DES DONNEES
//
// ===============================================================
$id_category=isset($_GET['id_category']) ? $_GET['id_category'] : (isset($_POST['id_category']) ? $_POST['id_category'] : NULL);
$id_subcategory=isset($_GET['id_subcategory']) ? $_GET['id_subcategory'] : (isset($_POST['id_subcategory']) ? $_POST['id_subcategory'] : NULL);
$submit_name=isset($_GET['submit_name']) ? $_GET['submit_name'] : (isset($_POST['submit_name']) ? $_POST['submit_name'] : NULL);
$new_name=isset($_GET['new_name']) ? $_GET['new_name'] : (isset($_POST['new_name']) ? $_POST['new_name'] : NULL);
$message = "";
$Categories = array();
$nbCategories = 0;
$style_specifique = "/mod_plugins/MesDocuments/views/style_mesdocuments";

// ===============================================================
//
//                       TESTS DE SECURITE
//
// ===============================================================
// Resume session
$resultat_session = $session_gepi->security_check();
if ($resultat_session == 'c') {
	header("Location: ../utilisateurs/mon_compte.php?change_mdp=yes");
	die();
} else if ($resultat_session == '0') {
	header("Location: ../logout.php?auto=1");
	die();
}
if (CurrentUserIsAllowed()) {
    // ===============================================================
    //
    //                  MODIFICATION DU NOM DE LA CATEGORIE
    //
    // ===============================================================
    if($submit_name != NULL) {
        ModifyCategoryName($id_category, $id_subcategory, $new_name, $message);
    }

    // ===============================================================
    //
    //                  RECUPERATION DU NOM DE LA CATEGORIE
    //
    // ===============================================================

    $old_name = RetrieveCategoryName($id_category, $id_subcategory);

    // ===============================================================
    //
    //                  RECUPERATION DES CATEGORIES
    //
    // ===============================================================
    $nbCategories = RetrieveCategories($Categories, $message);


    // =================== Tester la présence de IE6

    $IE6 = DetectIE6();

    // =================== Définir les droits d'accès au menu admin

    $AllowAdminMenu = DefineAdminMenuPermission();

    // =================== Définir le menu sélectionné

    $menu_item = "";

    // ===============================================================
    //
    //                              VUE
    //
    // ===============================================================

    require_once("../../lib/header.inc.php");
    DisplayEditCategoryView($message, $Categories, $nbCategories, $IE6, $AllowAdminMenu, $old_name, $id_category, $id_subcategory, $menu_item);
    require_once("../../lib/footer.inc.php");
}
else {
    // ===============================================================
    //
    //                              VUE
    //
    // ===============================================================

    require_once("../../lib/header.inc.php");
    DisplayDenyAccess();
    require_once("../../lib/footer.inc.php");
}
?>