<?php

/**
 * Fichier edit_links.php pour gérer des documents
 *
 *
 * Copyright 2010-2014 Pascal Fautrero, Bouguin Régis
 *
 * This file is part of MesDocuments, a plugin for GEPI.
 *
 * GEPI is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * MesDocuments is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with GEPI; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

$titre_page = "Mes Documents";
$affiche_connexion = 'yes';
$niveau_arbo = "2";


// ===============================================================
//
//                  IMPORTATION DES FONCTIONS ET CLASSES
//
// ===============================================================
include("./includes.php");

// ===============================================================
//
//                  INITIALISATION DES DONNEES
//
// ===============================================================

$id_link=isset($_GET['id_link']) ? $_GET['id_link'] : (isset($_POST['id_link']) ? $_POST['id_link'] : NULL);
$intitule=isset($_GET['intitule']) ? $_GET['intitule'] : (isset($_POST['intitule']) ? $_POST['intitule'] : NULL);
$description=isset($_GET['description']) ? $_GET['description'] : (isset($_POST['description']) ? $_POST['description'] : NULL);
$url=isset($_GET['url']) ? $_GET['url'] : (isset($_POST['url']) ? $_POST['url'] : NULL);
$update=isset($_GET['update']) ? $_GET['update'] : (isset($_POST['update']) ? $_POST['update'] : NULL);
$dirpath  =  RetrieveFolder();   
$message = "";
$AllowModification = false;
$allowed_user = array();
$tab = array();
$checkedlist = array();
$Categories = array();
$nbCategories = 0;
$style_specifique = "/mod_plugins/MesDocuments/views/style_mesdocuments";

// ===============================================================
//
//                  TESTS DE SECURITE
//
// ===============================================================
// Resume session
$resultat_session = $session_gepi->security_check();
if ($resultat_session == 'c') {
	header("Location: ../utilisateurs/mon_compte.php?change_mdp=yes");
	die();
} else if ($resultat_session == '0') {
	header("Location: ../logout.php?auto=1");
	die();
}
if (CurrentUserIsAllowed()) {
    // ===============================================================
    //
    //      RECUPERER LE STATUT DE L'UTILISATEUR
    //
    // ===============================================================

    $AllowModification = RetrieveAuthorizationStateForLink($id_link);

    // ===============================================================
    //
    //      MODIFICATION DES DROITS D'ACCES AU DOCUMENT
    //
    // ===============================================================

    if (($update == "ok") AND ($AllowModification)) {
        if ($id_link != NULL) {
            EditLinkInDatabase($id_link, $intitule, $description, $url, $message);
        }
    }


    // ===============================================================
    //
    //                   CREATION DE LA LISTBOX
    //
    // ===============================================================

    PrepareListBoxDatasFromUsers($tab, $checkedlist, RetrieveAuthorizedUsersForLink($id_link), RetrieveSubCategoryFromLink($id_link));
    $mychecklist = CreateListBox($tab, $checkedlist);


    // ===============================================================
    //
    //                  RECUPERATION DES CATEGORIES (POUR LE MENU)
    //
    // ===============================================================
    $nbCategories = RetrieveCategories($Categories, $message);

    // ===============================================================
    //
    //          RECUPERATION DE L'INTITULE ET DU DESCRIPTIF
    //
    // ===============================================================
    $intitule = RetrieveTitleLink($id_link, $message);
    $description = RetrieveDescriptionLink($id_link, $message);

    // =================== Tester la présence de IE6

    $IE6 = DetectIE6();

    // =================== Définir les droits d'accès au menu admin

    $AllowAdminMenu = DefineAdminMenuPermission();

    $url = RetrieveUrlFromId($id_link);

    // =================== Récupérer les statuts de GEPI pour la listbox

    $txtItem = RetrieveUsersStatus();

    // =================== Définir le menu sélectionné

    $menu_item = "";

    // ===============================================================
    //
    //                              VUE
    //
    // ===============================================================


    require_once("../../lib/header.inc.php");
    DisplayEditLinksView($message, $Categories, $nbCategories, $IE6, $AllowAdminMenu, $mychecklist, $id_link, $AllowAdminMenu, $AllowModification, $url, $txtItem, $intitule, $description, $menu_item);
    require_once("../../lib/footer.inc.php");
}
else {
    // ===============================================================
    //
    //                              VUE
    //
    // ===============================================================

    require_once("../../lib/header.inc.php");
    DisplayDenyAccess();
    require_once("../../lib/footer.inc.php");
}
?>