<?php

/**
 * Fichier edit_permissions.php pour gérer des documents
 *
 *
 * Copyright 2010-2014 Pascal Fautrero, Bouguin Régis
 *
 * This file is part of MesDocuments, a plugin for GEPI.
 *
 * GEPI is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * MesDocuments is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with GEPI; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

$titre_page = "Mes Documents";
$affiche_connexion = 'yes';
$niveau_arbo = "2";

// IMPORTATION DES FONCTIONS ET CLASSES
include("./includes.php");

// INITIALISATION DES DONNEES
$id_group=isset($_GET['id_group']) ? $_GET['id_group'] : (isset($_POST['id_group']) ? $_POST['id_group'] : NULL);
$update=isset($_GET['update']) ? $_GET['update'] : (isset($_POST['update']) ? $_POST['update'] : NULL);
$message = "";
$tab = array();
$checkedlist = array();
$Categories = array();
$nbCategories = 0;
$style_specifique = "/mod_plugins/MesDocuments/views/style_mesdocuments";

// TESTS DE SECURITE
$resultat_session = $session_gepi->security_check();
if ($resultat_session == 'c') {
	header("Location: ../utilisateurs/mon_compte.php?change_mdp=yes");
	die();
} else if ($resultat_session == '0') {
	header("Location: ../logout.php?auto=1");
	die();
}
if (CurrentUserIsAllowed()) {
    // MODIFICATION DES UTILISATEURS
    if ($update == "ok") {
        if ($id_group != NULL) {
            EditPermissionsGroup($id_group, $message);
        }
    }

    // VERIFICATION DES PERMISSIONS
    VerifyAclPermissionsTable();

    // RECUPERER LES PERMISSIONS PAR DEFAUT
    $DefaultPermission = RetrieveDefaultPermissions();

    // CREATION DE LA LISTBOX Catégories "Readable"
    PrepareListBoxCategories($tab, $checkedlist, RetrieveCategoriesFromGroup($id_group, "read"));
    $mychecklist1 = CreateListBoxCategories($tab, $checkedlist, 'table_cat_read');
    unset($tab);
    unset($checkedlist);
    $tab = array();
    $checkedlist = array();
    // CREATION DE LA LISTBOX Catégories "Writable"
    PrepareListBoxCategories($tab, $checkedlist, RetrieveCategoriesFromGroup($id_group, "write"));
    $mychecklist2 = CreateListBoxCategories($tab, $checkedlist, 'table_cat_write');
    unset($tab);
    unset($checkedlist);
    $tab = array();
    $checkedlist = array();
    // CREATION DE LA LISTBOX Sous-catégories "Readable"
    PrepareListBoxSubCategories($tab, $checkedlist, RetrieveSubCategoriesFromGroup($id_group, "read"));
    $mychecklist3 = CreateListBoxSubCategories($tab, $checkedlist, 'table_subcat_read');
    unset($tab);
    unset($checkedlist);
    $tab = array();
    $checkedlist = array();
    // CREATION DE LA LISTBOX Sous-catégories "Writable"
    PrepareListBoxSubCategories($tab, $checkedlist, RetrieveSubCategoriesFromGroup($id_group, "write"));
    $mychecklist4 = CreateListBoxSubCategories($tab, $checkedlist, 'table_subcat_write');


    // RECUPERATION DES CATEGORIES (POUR LE MENU)
    $nbCategories = RetrieveCategories($Categories, $message);

    // RECUPERATION DU NOM DU GROUPE
    $name_group = RetrieveGroupName($id_group);

    // Tester la présence de IE6
    $IE6 = DetectIE6();

    // Définir les droits d'accès au menu admin
    $AllowAdminMenu = DefineAdminMenuPermission();

    // Récupérer les statuts de GEPI pour la listbox
    $txtItem = RetrieveSimpleList();

    // Définir le menu sélectionné
    $menu_item = "groupes";

    // ===============================================================
    //
    //                              VUE
    //
    // ===============================================================

    require_once("../../lib/header.inc.php");
    DisplayEditPermissionsView($message, $Categories, $nbCategories, $IE6, $AllowAdminMenu, $mychecklist1, $mychecklist2,$mychecklist3,$mychecklist4, $name_group, $AllowAdminMenu, $txtItem, $id_group , $menu_item, $DefaultPermission);
    require_once("../../lib/footer.inc.php");
}
else {
    // ===============================================================
    //
    //                              VUE
    //
    // ===============================================================

    require_once("../../lib/header.inc.php");
    DisplayDenyAccess();
    require_once("../../lib/footer.inc.php");
}
?>