<?php

/**
 * Fichier folders.php pour gérer des documents
 *
 * Copyright 2010-2014 Pascal Fautrero, Bouguin Régis
 *
 * beta-testers : Didier Blanqui, Régis Bouguin
 *
 * This file is part of MesDocuments, a plugin for GEPI.
 *
 * GEPI is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * MesDocuments is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with GEPI; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

$titre_page = "Mes Documents";
$affiche_connexion = 'yes';
$niveau_arbo = "2";


// ===============================================================
//
//                  IMPORTATION DES FONCTIONS
//
// ===============================================================
include("./includes.php");

// ===============================================================
//
//                  INITIALISATION DES DONNEES
//
// ===============================================================
$submit_folder=isset($_GET['submit_folder']) ? $_GET['submit_folder'] : (isset($_POST['submit_folder']) ? $_POST['submit_folder'] : NULL);
$name_folder=isset($_GET['name_folder']) ? $_GET['name_folder'] : (isset($_POST['name_folder']) ? $_POST['name_folder'] : NULL);
$delete_folder=isset($_GET['delete_folder']) ? $_GET['delete_folder'] : (isset($_POST['delete_folder']) ? $_POST['delete_folder'] : NULL);
$define_default=isset($_GET['define_default']) ? $_GET['define_default'] : (isset($_POST['define_default']) ? $_POST['define_default'] : NULL);
$move_up=isset($_GET['move_up']) ? $_GET['move_up'] : (isset($_POST['move_up']) ? $_POST['move_up'] : NULL);
$move_down=isset($_GET['move_down']) ? $_GET['move_down'] : (isset($_POST['move_down']) ? $_POST['move_down'] : NULL);
$message = "";
$Categories = array();
$nbCategories = 0;
$style_specifique = "/mod_plugins/MesDocuments/views/style_mesdocuments";

// ===============================================================
//
//                       TESTS DE SECURITE
//
// ===============================================================
// Resume session
$resultat_session = $session_gepi->security_check();
if ($resultat_session == 'c') {
	header("Location: ../utilisateurs/mon_compte.php?change_mdp=yes");
	die();
} else if ($resultat_session == '0') {
	header("Location: ../logout.php?auto=1");
	die();
}
if (CurrentUserIsAllowed()) {
    // ===============================================================
    //
    //                  DEFINIR LA CATEGORIE PAR DEFAUT
    //                  SI AUCUNE CATEGORIE N'EST DEFINIE
    //
    // ===============================================================
    if (InvalidCategory(GetDefaultCategory())){
        SetDefaultCategory(RetrieveIDFirstCategory(), $message);
    }
    // ===============================================================
    //
    //                  DEFINIR LA CATEGORIE PAR DEFAUT
    //                  SI DEMANDE EXPLICITE
    //
    // ===============================================================
    if ($define_default != NULL) {
        if (InvalidCategory($define_default)){
            SetDefaultCategory(RetrieveIDFirstCategory(), $message);
        }
        else {
            SetDefaultCategory($define_default, $message);
        }
    }
    // ===============================================================
    //
    //                  CHANGER LE RANG D'AFFICHAGE
    //
    // ===============================================================
    if($move_up != NULL) {
        MoveUp($move_up, 'plugin_MDcategories', $message);
    }
    if($move_down != NULL) {
        MoveDown($move_down, 'plugin_MDcategories', $message);
    }
    // ===============================================================
    //
    //                  GESTION DE LA CREATION
    //
    // ===============================================================
    if($submit_folder != NULL) {
        $id_cat = CreateNewCategoryInDatabase($name_folder, $message);
        CreateNewSubCategoryInDatabase("Liste des Ressources", $id_cat, $message_temp);
    }

    // ===============================================================
    //
    //                  GESTION DE LA SUPPRESSION
    //
    // ===============================================================
    if ($delete_folder != NULL) {
        DeleteCategoryFromDatabase($delete_folder, $message);
    }

    // ===============================================================
    //
    //                  PREPARATION DU MENU
    //
    // ===============================================================
    $nbCategories = RetrieveCategories($Categories, $message);


    // =================== Tester la présence de IE6

    $IE6 = DetectIE6();

    // =================== Définir les droits d'accès au menu admin

    $AllowAdminMenu = DefineAdminMenuPermission();

    // =================== Définir le menu sélectionné

    $menu_item = "catégories";

    // ===============================================================
    //
    //                              VUE
    //
    // ===============================================================

    require_once("../../lib/header.inc.php");
    DisplayFolderView($message, $Categories, $nbCategories, $IE6, $AllowAdminMenu, $menu_item);
    require_once("../../lib/footer.inc.php");
}
else {
    // ===============================================================
    //
    //                              VUE
    //
    // ===============================================================

    require_once("../../lib/header.inc.php");
    DisplayDenyAccess();
    require_once("../../lib/footer.inc.php");
}
?>