<?php

/**
 * Fichier groups.php pour gérer des documents
 *
 * Copyright 2010-2014 Pascal Fautrero, Bouguin Régis
 *
 * beta-testers : Didier Blanqui, Régis Bouguin
 *
 * This file is part of MesDocuments, a plugin for GEPI.
 *
 * GEPI is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * MesDocuments is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with GEPI; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

$titre_page = "Mes Documents";
$affiche_connexion = 'yes';
$niveau_arbo = "2";


// ===============================================================
//
//                  IMPORTATION DES FONCTIONS
//
// ===============================================================
include("./includes.php");
// ===============================================================
//
//                  INITIALISATION DES DONNEES
//
// ===============================================================
$submit_group=isset($_GET['submit_group']) ? $_GET['submit_group'] : (isset($_POST['submit_group']) ? $_POST['submit_group'] : NULL);
$name_group=isset($_GET['name_group']) ? $_GET['name_group'] : (isset($_POST['name_group']) ? $_POST['name_group'] : NULL);
$swap_permission=isset($_GET['swap_permission']) ? $_GET['swap_permission'] : (isset($_POST['swap_permission']) ? $_POST['swap_permission'] : NULL);
$delete_group=isset($_GET['delete_group']) ? $_GET['delete_group'] : (isset($_POST['delete_group']) ? $_POST['delete_group'] : NULL);
$swap_userfilter=isset($_GET['swap_userfilter']) ? $_GET['swap_userfilter'] : (isset($_POST['swap_userfilter']) ? $_POST['swap_userfilter'] : NULL);
$message = "";
$Categories = array();
$nbCategories = 0;
$Groups = array();
$nbGroups = 0;
$style_specifique = "/mod_plugins/MesDocuments/views/style_mesdocuments";

// ===============================================================
//
//                       TESTS DE SECURITE
//
// ===============================================================
// Resume session
$resultat_session = $session_gepi->security_check();
if ($resultat_session == 'c') {
	header("Location: ../utilisateurs/mon_compte.php?change_mdp=yes");
	die();
} else if ($resultat_session == '0') {
	header("Location: ../logout.php?auto=1");
	die();
}
if (CurrentUserIsAllowed()) {

    // ===============================================================
    //
    //                  GESTION DE LA CREATION
    //
    // ===============================================================
    if($submit_group != NULL) {
        CreateGroup($name_group, $message);
    }

    // ===============================================================
    //
    //                  GESTION DE LA SUPPRESSION
    //
    // ===============================================================
    if ($delete_group != NULL) {
        DeleteGroup($delete_group, $message);
    }

    // ===============================================================
    //
    //                  RECUPERATION DES GROUPES
    //
    // ===============================================================
    $nbGroups = RetrieveGroups($Groups, $message);

    // ===============================================================
    //
    //                  RECUPERATION DES CATEGORIES
    //
    // ===============================================================
    $nbCategories = RetrieveCategories($Categories, $message);


    // =================== Tester la présence de IE6

    $IE6 = DetectIE6();

    // =================== Définir les droits d'accès au menu admin

    $AllowAdminMenu = DefineAdminMenuPermission();

    // =================== Définir le menu sélectionné

    $menu_item = "groupes";

    // ===============================================================
    //
    //                              VUE
    //
    // ===============================================================

    require_once("../../lib/header.inc.php");
    DisplayGroupsView($message, $Categories, $nbCategories, $IE6, $AllowAdminMenu, $Groups, $nbGroups, $menu_item);
    require_once("../../lib/footer.inc.php");
}
else {
    // ===============================================================
    //
    //                              VUE
    //
    // ===============================================================
    require_once("../../lib/header.inc.php");
    DisplayDenyAccess();
    require_once("../../lib/footer.inc.php");
}
?>