<?php

/**
 * Fichier index.php pour gérer des documents
 *
 * Copyright 2010-2014 Pascal Fautrero, Bouguin Régis
 *
 * beta-testers : Didier Blanqui, Régis Bouguin, Eric Abgrall
 *
 * This file is part of MesDocuments, a plugin for GEPI.
 *
 * GEPI is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * MesDocuments is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with GEPI; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

$titre_page = "Mes Documents";
$affiche_connexion = 'yes';
$niveau_arbo = "2";


// ===============================================================
//
//                  IMPORTATION DES FONCTIONS
//
// ===============================================================
include("./includes.php");
// echo "includes.php";
// ===============================================================
//
//                  INITIALISATION DES DONNEES
//
// ===============================================================
$download=isset($_GET['download']) ? $_GET['download'] : (isset($_POST['download']) ? $_POST['download'] : NULL);
$delete=isset($_GET['delete']) ? $_GET['delete'] : (isset($_POST['delete']) ? $_POST['delete'] : NULL);
$delete_subcategory=isset($_GET['delete_subcategory']) ? $_GET['delete_subcategory'] : (isset($_POST['delete_subcategory']) ? $_POST['delete_subcategory'] : NULL);
$id_category=isset($_GET['id_category']) ? $_GET['id_category'] : (isset($_POST['id_category']) ? $_POST['id_category'] : NULL);
$delete_link=isset($_GET['delete_link']) ? $_GET['delete_link'] : (isset($_POST['delete_link']) ? $_POST['delete_link'] : NULL);
$submit_subfolder=isset($_GET['submit_subfolder']) ? $_GET['submit_subfolder'] : (isset($_POST['submit_subfolder']) ? $_POST['submit_subfolder'] : NULL);
$name_subfolder=isset($_GET['name_subfolder']) ? $_GET['name_subfolder'] : (isset($_POST['name_subfolder']) ? $_POST['name_subfolder'] : NULL);
$move_up=isset($_GET['move_up']) ? $_GET['move_up'] : (isset($_POST['move_up']) ? $_POST['move_up'] : NULL);
$move_down=isset($_GET['move_down']) ? $_GET['move_down'] : (isset($_POST['move_down']) ? $_POST['move_down'] : NULL);
$folder = RetrieveFolder();
$message = "";
$MyFiles = array();
$AllowDisplayButtons = array();
$AllowDisplayFile = array();
$MyLinks = array();
$AllowDisplayButtonsLink = array();
$AllowDisplayLink = array();
$Categories = array();
$nbCategories = 0;
$SubCategories = array();
$nbSubCategories = 0;
$Category_readable = false;
$Category_writable = false;
$style_specifique = "mod_plugins/MesDocuments/views/style_mesdocuments";

// TESTS DE SECURITE
$resultat_session = $session_gepi->security_check();
if ($resultat_session == 'c') {
	header("Location: ../utilisateurs/mon_compte.php?change_mdp=yes");
	die();
} else if ($resultat_session == '0') {
	header("Location: ../logout.php?auto=1");
	die();
}

//echo "Tests sécurité passés";

if (CurrentUserIsAllowed()) {
    // VERIFICATION SUR LA BASE
    VerifyTablePlugin();
// echo "VerifyTablePlugin() → ok <br />";
    VerifyAclTables();
	//echo "VerifyAclTables() → ok <br />";
    UpdateOldVersion();
// echo "mise à jour vieille version → ok <br />";
    // CREATION D'UN GROUPE 'COMMUNAUTE'
    // DANS LE CAS OU IL N'EN EXISTE AUCUN
    if (RetrieveGroups($Group_tmp, $message) == 0) {
        CreateGroup('Communauté', $message);
		//echo "coucou";
        InsertAllUsersInCommunity();
        $message = "";
    }
    IncludeUserInCommunityIfAlone(strtolower($_SESSION['login']));
// echo "CREATION D'UN GROUPE 'COMMUNAUTE → ok <br />";

    // CREATION D'UN COUPLE CATEGORIE/SOUS-CATEGORIE
    // DANS LE CAS OU IL N'EN EXISTE AUCUN
    $nbCategories = RetrieveCategories($Categories, $message);
    if ($nbCategories == 0) {
        $id_cat = CreateNewCategoryInDatabase("Mes Documents", $message);
        CreateNewSubCategoryInDatabase("Liste des Ressources", $id_cat, $message);
        $message = "";
    }


    // CHANGER LE RANG D'AFFICHAGE SUR DEMANDE
    if($move_up != NULL) {
        MoveUp($move_up, 'plugin_MDsubcategories', $message);
    }
    if($move_down != NULL) {
        MoveDown($move_down, 'plugin_MDsubcategories', $message);
    }

    // CREATION D'UNE SOUS-CATEGORIE SUR DEMANDE
    if($submit_subfolder != NULL) {
        CreateNewSubCategoryInDatabase($name_subfolder, $id_category, $message);
    }

    // SUPPRESSION D'UNE SOUS-CATEGORIE SUR DEMANDE
    if($delete_subcategory != NULL) {
        DeleteSubCategoryFromDatabase($delete_subcategory, $message);
    }

    // GESTION DU TELECHARGEMENT SUR DEMANDE
    if($download != NULL) {
        DownloadFile($download, $message);
    }

    // SUPPRESSION D'UN LIEN SUR DEMANDE
    if($delete_link != NULL) {
        DeleteLinkFromDatabase($delete_link, $message);
    }

    // SUPPRESSION D'UN DOCUMENT SUR DEMANDE
    if ($delete != NULL) {
        if (DeleteDocumentFromDirectory($delete, $message)) {
            DeleteDocumentFromDatabase($delete);
        }
    }

    // RECUPERATION DE LA CATEGORIE PAR DEFAUT
    if ($id_category == NULL) {
        if (GetDefaultCategory() == 0) {
            SetDefaultCategory(1, $message);
        }
        $id_category = GetDefaultCategory();
    }

    // RECUPERATION DES SOUS-CATEGORIES
    $nbSubCategories = RetrieveSubCategories($SubCategories, $id_category, $message);

// echo 'RECUPERATION DES SOUS-CATEGORIES → ok <br />';

    // RECUPERATION DES FICHIERS
    if (!is_dir($folder)) {
		//echo 'is_not_dir()<br />';
        CreateDirectory($folder);
		//echo 'is_not_dir() créée<br />';
        CreateProtectionFile();
    }
    else {
		//echo 'is_dir()<br />';
        RetrieveDocuments($MyFiles, $AllowDisplayFile, $AllowDisplayButtons, $id_category);
		//echo 'is_dir() trouvée<br />';
    }

    // RECUPERATION DES LIENS
    RetrieveLinks($MyLinks, $AllowDisplayLink, $AllowDisplayButtonsLink, $id_category);

    // RECUPERATION DES CATEGORIES (POUR LE MENU)
    $nbCategories = RetrieveCategories($Categories, $message);

// echo 'RECUPERATION DES CATEGORIES → ok <br />';
    // Récupérer les permissions de la catégorie
    RetrievePermissionsCurrentCategory($Category_readable, $Category_writable, $Categories, $id_category);

// echo 'Permissions CATEGORIES → ok <br />';
    // Tester la présence de IE6
    $IE6 = DetectIE6();

// echo 'IE6 → ok <br />';
    // Définir les droits d'accès au menu admin
    $AllowAdminMenu = DefineAdminMenuPermission();

    // Définir le menu sélectionné
    $menu_item = $id_category;
	
// echo 'Affichage';

    // ===============================================================
    //
    //                              VUE
    //
    // ===============================================================
    require_once("../../lib/header.inc.php");
    DisplayIndexView($message, $MyFiles, $AllowDisplayFile, $AllowDisplayButtons, $AllowAdminMenu, $id_category, $IE6, $Categories, $nbCategories, $SubCategories, $nbSubCategories, $MyLinks, $AllowDisplayLink, $AllowDisplayButtonsLink, $menu_item, $Category_readable, $Category_writable);
    require_once("../../lib/footer.inc.php");
}
else {
    // ===============================================================
    //
    //                              VUE
    //
    // ===============================================================
    require_once("../../lib/header.inc.php");
    DisplayDenyAccess();
    require_once("../../lib/footer.inc.php");
}
?>