addEvent(window, "load", sortables_init);

//global variables that can be used by ALL the function son this page.
var imgFalse = 'listbox/false.gif';
var imgTrue = 'listbox/true.gif';
var imgUp = '<img src="listbox/uparrow.png" style="border:none;" alt=""/>';
var imgDown = '<img src="listbox/downarrow.png" style="border:none;" alt=""/>';

var inputs; 
var SORT_COLUMN_INDEX;



function sortables_init() {
    // Find all tables with class sortable and make them sortable
    if (!document.getElementsByTagName) return;
    tbls = document.getElementsByTagName("table");
    for (ti=0;ti<tbls.length;ti++) {
        thisTbl = tbls[ti];
        if (((' '+thisTbl.className+' ').indexOf("sortable") != -1) && (thisTbl.id)) {
            //initTable(thisTbl.id);
            ts_makeSortable(thisTbl);
        }
    }
}

function ts_makeSortable(table) {
    if (table.rows && table.rows.length > 0) {
        var firstRow = table.rows[0];
    }
    if (!firstRow) return;
    
    // We have a first row: assume it's the header, and make its contents clickable links
    for (var i=0;i<firstRow.cells.length;i++) {
        var cell = firstRow.cells[i];
        var txt = ts_getInnerText(cell);
        cell.innerHTML = '<a href="#" id="link_'+table.id+'_'+i+'" class="sortheader" onclick="ts_resortTable(this);return false;">'+txt+'<span class="sortarrow"></span></a>';
    }
}

function ts_getInnerText(el) {
	if (typeof el == "string") return el;
	if (typeof el == "undefined") { return el };
	if (el.innerText) return el.innerText;	//Not needed but it is faster
	var str = "";
	
	var cs = el.childNodes;
	var l = cs.length;
	for (var i = 0; i < l; i++) {
		switch (cs[i].nodeType) {
			case 1: //ELEMENT_NODE
				str += ts_getInnerText(cs[i]);
				break;
			case 3:	//TEXT_NODE
				str += cs[i].nodeValue;
				break;
		}
	}
	return str;
}




function ts_resortTable(reference, number_ref, lnk) {
    // get the span
    var span;
    for (var ci=0;ci<lnk.childNodes.length;ci++) {
        if (lnk.childNodes[ci].tagName && lnk.childNodes[ci].tagName.toLowerCase() == 'span') 
			{
				span = lnk.childNodes[ci];
			}
    }
	
    var spantext = ts_getInnerText(span);
    var td = lnk.parentNode;
    var column = td.cellIndex;
    var table = getParent(td,'TABLE');

    // Work out a type for the column
    if (table.rows.length <= 1) return;
    var itm = ts_getInnerText(table.rows[1].cells[column]);
    sortfn = ts_sort_caseinsensitive;
	if (itm.match(/^[\d &euro;]/)) sortfn = ts_sort_currency;
    if (itm.match(/^\d\d[\/-]\d\d[\/-]\d\d\d\d$/)) sortfn = ts_sort_date;
    if (itm.match(/^\d\d[\/-]\d\d[\/-]\d\d$/)) sortfn = ts_sort_date;
    if (itm.match(/^[\d\.]+$/)) sortfn = ts_sort_numeric;
    SORT_COLUMN_INDEX = column;
    var firstRow = new Array();
    var newRows = new Array();
    for (i=0;i<table.rows[0].length;i++) { firstRow[i] = table.rows[0][i]; }
    for (j=1;j<table.rows.length;j++) { newRows[j-1] = table.rows[j]; }

    newRows.sort(sortfn);


    if (span.getAttribute("sortdir") == 'down') {
        ARROW = '&nbsp;&nbsp;'+imgDown;
        newRows.reverse();
        span.setAttribute('sortdir','up');
    } else {
        ARROW = '&nbsp;&nbsp;'+imgUp;
        span.setAttribute('sortdir','down');
    }
    
    // We appendChild rows that already exist to the tbody, so it moves them rather than creating new ones
    // don't do sortbottom rows
    for (i=0;i<newRows.length;i++) { if (!newRows[i].className || (newRows[i].className && (newRows[i].className.indexOf('sortbottom') == -1))) table.tBodies[0].appendChild(newRows[i]);}
    // do sortbottom rows only
    for (i=0;i<newRows.length;i++) { if (newRows[i].className && (newRows[i].className.indexOf('sortbottom') != -1)) table.tBodies[0].appendChild(newRows[i]);}
    
	// recoche les cases enlevés par IE, pas besoin sous FF
	for (i=1; i<table.rows.length; i++)
	{
		if (table.rows[i].id)
		{
			nno = table.rows[i].id;
			elem = reference+'_'+inputs[nno].value+'checkImage'+inputs[nno].value;
			thesource = document.getElementById(elem).src ;
			
			if (thesource.indexOf(imgTrue,0) != -1)
				inputs[nno].checked = 'checked';
			else
				inputs[nno].checked = '';
			
		}
	}
		

	// Affiche ou non les liens up et down sur les colonnes
	var allTDs = table.getElementsByTagName("th");
	for (i=0;i<allTDs.length;i++)
	{
		if (i == number_ref) 
  		 document.getElementById('header_'+reference+'_'+i).innerHTML =document.getElementById('link_'+reference+'_'+i).innerHTML+ARROW; 
		else 
		 document.getElementById('header_'+reference+'_'+i).innerHTML =document.getElementById('link_'+reference+'_'+i).innerHTML; 
	}
	
}

function getParent(el, pTagName) {
	if (el == null) return null;
	else if (el.nodeType == 1 && el.tagName.toLowerCase() == pTagName.toLowerCase())	// Gecko bug, supposed to be uppercase
		return el;
	else
		return getParent(el.parentNode, pTagName);
}
function ts_sort_date(a,b) {
    // y2k notes: two digit years less than 50 are treated as 20XX, greater than 50 are treated as 19XX
    aa = ts_getInnerText(a.cells[SORT_COLUMN_INDEX]);
    bb = ts_getInnerText(b.cells[SORT_COLUMN_INDEX]);
    if (aa.length == 10) {
        dt1 = aa.substr(6,4)+aa.substr(3,2)+aa.substr(0,2);
    } else {
        yr = aa.substr(6,2);
        if (parseInt(yr) < 50) { yr = '20'+yr; } else { yr = '19'+yr; }
        dt1 = yr+aa.substr(3,2)+aa.substr(0,2);
    }
    if (bb.length == 10) {
        dt2 = bb.substr(6,4)+bb.substr(3,2)+bb.substr(0,2);
    } else {
        yr = bb.substr(6,2);
        if (parseInt(yr) < 50) { yr = '20'+yr; } else { yr = '19'+yr; }
        dt2 = yr+bb.substr(3,2)+bb.substr(0,2);
    }
    if (dt1==dt2) return 0;
    if (dt1<dt2) return -1;
    return 1;
}

function ts_sort_currency(a,b) { 
    aa = ts_getInnerText(a.cells[SORT_COLUMN_INDEX]).replace(/[^0-9.]/g,'');
    bb = ts_getInnerText(b.cells[SORT_COLUMN_INDEX]).replace(/[^0-9.]/g,'');
    return parseFloat(aa) - parseFloat(bb);
}

function ts_sort_numeric(a,b) { 
    aa = parseFloat(ts_getInnerText(a.cells[SORT_COLUMN_INDEX]));
    if (isNaN(aa)) aa = 0;
    bb = parseFloat(ts_getInnerText(b.cells[SORT_COLUMN_INDEX])); 
    if (isNaN(bb)) bb = 0;
    return aa-bb;
}

function ts_sort_caseinsensitive(a,b) {
    aa = ts_getInnerText(a.cells[SORT_COLUMN_INDEX]).toLowerCase();
    bb = ts_getInnerText(b.cells[SORT_COLUMN_INDEX]).toLowerCase();
    if (aa==bb) return 0;
    if (aa<bb) return -1;
    return 1;
}

function ts_sort_default(a,b) {
    aa = ts_getInnerText(a.cells[SORT_COLUMN_INDEX]);
    bb = ts_getInnerText(b.cells[SORT_COLUMN_INDEX]);
    if (aa==bb) return 0;
    if (aa<bb) return -1;
    return 1;
}


function addEvent(elm, evType, fn, useCapture)
// addEvent and removeEvent
// cross-browser event handling for IE5+,  NS6 and Mozilla
// By Scott Andrew
{
  if (elm.addEventListener){
    elm.addEventListener(evType, fn, useCapture);
    return true;
  } else if (elm.attachEvent){
    var r = elm.attachEvent("on"+evType, fn);
    return r;
  } else {
    alert("Handler could not be removed");
  }
} 




//this function runs when the page is loaded, put all your other onload stuff in here too.
function init() {
	replaceChecks();

}

function replaceChecks() {
	
	//get all the input fields on the page
	inputs = document.getElementsByTagName('input');

	//cycle trough the input fields
	for(var i=0; i < inputs.length; i++) {

		//check if the input is a checkbox
		if(inputs[i].getAttribute('type') == 'checkbox' && inputs[i].className == 'listbox_box')
 		{
	
			//create a new image
			var img = document.createElement('img');
			
			//check if the checkbox is checked	
			if(inputs[i].parentNode.parentNode.className == 'sortable_row_on')
			 {
			 	inputs[i].checked = 'checked';
				img.src = imgTrue;
				inputs[i].parentNode.parentNode.className = 'sortable_row_on';
			} else {
				inputs[i].checked = '';
				img.src = imgFalse;
				inputs[i].parentNode.parentNode.className = 'sortable_row_off';
			}
						
			//set image ID and onclick action
			img.id = inputs[i].name+'checkImage'+inputs[i].value;
		
			//place image in front of the checkbox
			inputs[i].parentNode.insertBefore(img, inputs[i]);
		}
	}
}

//change the checkbox status and the replacement image
function checkChange(i, index) {
	nno = document.getElementById(index+'checkImage'+i).parentNode.parentNode.id;
	
	if(inputs[nno].parentNode.parentNode.className == 'sortable_row_on') {
		document.getElementById(index+'checkImage'+i).src=imgFalse;
		inputs[nno].checked = '';
	} else {
		document.getElementById(index+'checkImage'+i).src=imgTrue;
		inputs[nno].checked = 'checked';
	}

	if (index)
	{
		myobj = document.getElementById(index);
		if (myobj.className == 'sortable_row_off')
			myobj.className = 'sortable_row_on';
		else
			myobj.className = 'sortable_row_off';
	}
}

function checkChangeLink(table, cible) {
	table =document.getElementById(table);
    i = 0;
	for (i=0; i<inputs.length-1; i++)
	{

		if(inputs[i].getAttribute('type') == 'checkbox' && 
			inputs[i].className == 'listbox_box' && 
			inputs[i].name == table.id+'_'+inputs[i].value)
		{
			if (cible == 'tous')
			{
				nno = document.getElementById(inputs[i].name+'checkImage'+inputs[i].value).parentNode.parentNode;
				inputs[i].checked = 'checked';
				document.getElementById(inputs[i].name+'checkImage'+inputs[i].value).src=imgTrue;
				document.getElementById(nno.id).className = 'sortable_row_on';
			}
			else if (cible == 'aucun')
			{
				nno = document.getElementById(inputs[i].name+'checkImage'+inputs[i].value).parentNode.parentNode;
				inputs[i].checked = '';
				document.getElementById(inputs[i].name+'checkImage'+inputs[i].value).src=imgFalse;
				document.getElementById(nno.id).className = 'sortable_row_off';
			}
			else
			{
                            if (cible == 'oui')
                            {
                                if (document.all) {
                                    indexStatus = 5;
                                }
                                else {
                                    indexStatus = 6;
                                }
                            }
                            else {
                                if (document.all) {
                                    indexStatus = 4;
                                }
                                else {
                                    indexStatus = 5;
                                }
                            }
                            
                            if (document.getElementById(inputs[i].name+'checkImage'+inputs[i].value).parentNode.parentNode.childNodes[indexStatus].innerHTML == cible)
                            {
                                
                                                nno = document.getElementById(inputs[i].name+'checkImage'+inputs[i].value).parentNode.parentNode;
                                                inputs[i].checked = 'checked';
                                                document.getElementById(inputs[i].name+'checkImage'+inputs[i].value).src=imgTrue;
                                                document.getElementById(nno.id).className = 'sortable_row_on';
                            }
			}
		}
	}
}


window.onload = init;
