<?php
/**
 * Fichier CategoriesAcl.php pour gérer des droits
 *
 *
 * Copyright 2010 Pascal Fautrero
 *
 * This file is part of MesDocuments, a plugin for GEPI.
 *
 * GEPI is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * MesDocuments is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with GEPI; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
// ===============================================================
//
//              INSERER L'UTILISATEUR COURANT DANS 'COMMUNAUTE'
//
// ===============================================================
function IncludeUserInCommunityIfAlone($login)
{
	global $mysqli;
    $sql_request = "SELECT id_group FROM plugin_MDusers WHERE login = '".$login."' ";
    $req_state = mysqli_query($mysqli, $sql_request) or die(mysqli_error($mysqli));
    if (mysqli_num_rows($req_state) == 0) {
        $sql_request = "INSERT INTO plugin_MDusers (id_group, login) VALUES ('1', '".$login."') ";
        mysqli_query($mysqli, $sql_request) or die(mysqli_error($mysqli));
    }
}
// ===============================================================
//
//              INSERER TOUS LES UTILISATEURS DANS 'COMMUNAUTE'
//
// ===============================================================
function InsertAllUsersInCommunity()
{
	global $mysqli;
    $req_destinataires = mysqli_query($mysqli, "SELECT login FROM utilisateurs WHERE
                                            statut = 'administrateur' OR
                                            statut = 'professeur' OR
                                            statut = 'cpe' OR
                                            statut = 'scolarite' OR
                                            statut = 'autre' ORDER BY nom ASC") or die(mysqli_error($mysqli));
    if ($req_destinataires) {
        while ($rep_destinataires = mysqli_fetch_array($req_destinataires)) {
            $sql_request = "SELECT login FROM plugin_MDusers WHERE login = '".$rep_destinataires['login']."' ";
            $req_state = mysqli_query($mysqli, $sql_request);
            if ($req_state) {
                if (mysqli_num_rows($req_state) == 0) {
                    $sql_request = "INSERT INTO plugin_MDusers (id_group, login) VALUES ('1', '".strtolower($rep_destinataires['login'])."') ";
                    mysqli_query($mysqli, $sql_request) or die(mysqli_error($mysqli));
                }
            }
        }
    }
}
// ===============================================================
//
//              RECUPERER LES PERMISSIONS POUR L'UTILISATEUR
//
// ===============================================================
function RetrieveAllowedUsersInSubCategory($id_subcategory, $access)
{
	global $mysqli;
    $DefaultPermission = RetrieveDefaultPermissions();

    $req_destinataires = mysqli_query($mysqli, "SELECT login FROM utilisateurs WHERE
                                            statut = 'administrateur' OR
                                            statut = 'professeur' OR
                                            statut = 'cpe' OR
                                            statut = 'scolarite' OR
                                            statut = 'autre' ORDER BY nom ASC") or die(mysqli_error($mysqli));

    $sql_request = "SELECT id_group FROM plugin_MDpermissions WHERE
                                        id_subcategory = '".$id_subcategory."' AND
                                        access = '".$access."' ";

    $Users = array();
    if ($req_groups = mysqli_query($mysqli, $sql_request)) {
        $i = 0;
        while ($rep_groups = mysqli_fetch_array($req_groups)) {
            $sql_request = "SELECT login FROM plugin_MDusers WHERE
                                            id_group = '".$rep_groups['id_group']."' ";
            $req_login = mysqli_query($mysqli, $sql_request) or die(mysqli_error($mysqli));
            if ($req_login) {
                while ($rep_login = mysqli_fetch_array($req_login)) {
                    if (!in_array(strtolower($rep_login['login']), $Users)) {
                        $Users[$i] = strtolower($rep_login['login']);
                        $i++;
                    }
                }
            }

        }
    }

    $FinalUsers = array();
    while ($rep_destinataires = mysqli_fetch_array($req_destinataires)) {
        if ($DefaultPermission == "allow") {
            if (!in_array(strtolower($rep_destinataires['login']), $Users)) {
                $FinalUsers[] = strtolower($rep_destinataires['login']);
            }
        }
        else {
            if (in_array(strtolower($rep_destinataires['login']), $Users)) {
                $FinalUsers[] = strtolower($rep_destinataires['login']);
            }
        }
    }
    return $FinalUsers;
}
// ===============================================================
//
//              RECUPERER L'ID D'UNE CATEGORIE
//
// ===============================================================
function RetrieveCategoryFromSubCategory($id_subcategory)
{
	global $mysqli;
    $id = "";
    if ($id_subcategory != NULL) {
        $sql_request = "SELECT id_category FROM plugin_MDsubcategories WHERE id = '".$id_subcategory."' ";
        $req_id = mysqli_query($mysqli, $sql_request);
        if ($req_id) {
            if ($rep_id = mysqli_fetch_array($req_id)) {
                $id = $rep_id['id_category'];
            }
        }
    }

    return $id;
}
// ===============================================================
//
//              RECUPERER LES PERMISSIONS POUR L'UTILISATEUR
//
// ===============================================================
function SubCategoryWritable($id_subcategory, $login)
{
	global $mysqli;
    $DefaultPermission = RetrieveDefaultPermissions();
    if ($DefaultPermission == "allow") {
        $result = true;
    }
    else {
        $result = false;
    }
    $sql_request = "SELECT id_group FROM plugin_MDusers WHERE login = '".$login."' ";
    if ($req_groups = mysqli_query($mysqli, $sql_request)) {
        while ($rep_groups = mysqli_fetch_array($req_groups)) {
            $sql_request = "SELECT access FROM plugin_MDpermissions WHERE
                                            id_group = '".$rep_groups['id_group']."' AND
                                            id_subcategory = '".$id_subcategory."' AND
                                            access = 'write' ";
            $req_access = mysqli_query($mysqli, $sql_request) or die(mysqli_error($mysqli));
            if ($req_access) {
                while ($rep_access = mysqli_fetch_array($req_access)) {
                    if ($DefaultPermission == "allow") {
                        $result = false;
                    }
                    else {
                        $result = true;
                    }
                }
            }
        }
    }
    return $result;
}
// ===============================================================
//
//              RECUPERER LES PERMISSIONS POUR L'UTILISATEUR
//
// ===============================================================
function CategoryWritable($id_category, $login)
{
	global $mysqli;
    $DefaultPermission = RetrieveDefaultPermissions();
    if ($DefaultPermission == "allow") {
        $result = true;
    }
    else {
        $result = false;
    }
    $sql_request = "SELECT id_group FROM plugin_MDusers WHERE login = '".$login."' ";
    //if ($req_groups = mysql_query($sql_request)) {
    if ($req_groups = mysqli_query($mysqli, $sql_request)) {
        while ($rep_groups = mysqli_fetch_array($req_groups)) {
            $sql_request = "SELECT access FROM plugin_MDpermissions WHERE
                                            id_group = '".$rep_groups['id_group']."' AND
                                            id_category = '".$id_category."' AND
                                            access = 'write' ";
            $req_access = mysqli_query($mysqli, $sql_request) or die(mysqli_error($mysqli));
            if ($req_access) {
                while ($rep_access = mysqli_fetch_array($req_access)) {
                    if ($DefaultPermission == "allow") {
                        $result = false;
                    }
                    else {
                        $result = true;
                    }
                }
            }
        }
    }
    return $result;
}
// ===============================================================
//
//              RECUPERER LES PERMISSIONS DE LA CATEGORIE
//
// ===============================================================
function RetrievePermissionsCurrentCategory(&$Category_readable, &$Category_writable, $Categories, $id_category)
{
    $DefaultPermission = RetrieveDefaultPermissions();
    if ($DefaultPermission == "allow") {
        $Category_readable = true;
        $Category_writable = true;
    }
    else {
        $Category_readable = false;
        $Category_writable = false;
    }
    $i = 0;
    while (isset($Categories[$i]['id'])) {
        if ($Categories[$i]['id'] == $id_category) {
            $Category_readable = $Categories[$i]['readable'];
            $Category_writable = $Categories[$i]['writable'];
        }
        $i++;
    }
}
// ===============================================================
//
//              RECUPERER LES PERMISSIONS POUR L'UTILISATEUR
//
// ===============================================================
function RetrieveUserPermissionsSubCategories(&$Categories, $login)
{
	global $mysqli;
    $DefaultPermission = RetrieveDefaultPermissions();
    $i = 0;
    while (isset($Categories[$i]['id'])) {
        if ($DefaultPermission == "allow") {
            $Categories[$i]['readable'] = true;
            $Categories[$i]['writable'] = true;
        }
        else {
            $Categories[$i]['readable'] = false;
            $Categories[$i]['writable'] = false;
        }
        $i++;
    }

    $sql_request = "SELECT id_group FROM plugin_MDusers WHERE login = '".$login."' ";
    if ($req_groups = mysqli_query($mysqli, $sql_request)) {
        while ($rep_groups = mysqli_fetch_array($req_groups)) {
            $i = 0;
            while (isset($Categories[$i]['id'])) {

                $sql_request = "SELECT access FROM plugin_MDpermissions WHERE
                                                id_group = '".$rep_groups['id_group']."' AND
                                                id_subcategory = '".$Categories[$i]['id']."' ";
                $req_access = mysqli_query($mysqli, $sql_request) or die(mysqli_error($mysqli));
                if ($req_access) {
                    while ($rep_access = mysqli_fetch_array($req_access)) {
                        if ($rep_access['access'] == "read") {
                            if ($DefaultPermission == "allow") {
                                $Categories[$i]['readable'] = false;
                            }
                            else {
                                $Categories[$i]['readable'] = true;
                            }
                        }
                        else if ($rep_access['access'] == "write") {
                            if ($DefaultPermission == "allow") {
                                $Categories[$i]['writable'] = false;
                            }
                            else {
                                $Categories[$i]['writable'] = true;
                            }
                        }
                    }
                }
                $i++;
            }
        }
    }
}
// ===============================================================
//
//              RECUPERER LES PERMISSIONS POUR L'UTILISATEUR
//
// ===============================================================
function RetrieveUserPermissions(&$Categories, $login)
{
	global $mysqli;
    $DefaultPermission = RetrieveDefaultPermissions();
    $i = 0;
    while (isset($Categories[$i]['id'])) {
        if ($DefaultPermission == "allow") {
            $Categories[$i]['readable'] = true;
            $Categories[$i]['writable'] = true;
        }
        else {
            $Categories[$i]['readable'] = false;
            $Categories[$i]['writable'] = false;
        }
        $i++;
    }

    $sql_request = "SELECT id_group FROM plugin_MDusers WHERE login = '".$login."' ";
    if ($req_groups = mysqli_query($mysqli, $sql_request)) {
        while ($rep_groups = mysqli_fetch_array($req_groups)) {
            $i = 0;
            while (isset($Categories[$i]['id'])) {

                $sql_request = "SELECT access FROM plugin_MDpermissions WHERE
                                                id_group = '".$rep_groups['id_group']."' AND
                                                id_category = '".$Categories[$i]['id']."' ";
                $req_access = mysqli_query($mysqli, $sql_request) or die(mysqli_error($mysqli));
                if ($req_access) {
                    while ($rep_access = mysqli_fetch_array($req_access)) {
                        if ($rep_access['access'] == "read") {
                            if ($DefaultPermission == "allow") {
                                $Categories[$i]['readable'] = false;
                            }
                            else {
                                $Categories[$i]['readable'] = true;
                            }
                        }
                        else if ($rep_access['access'] == "write") {
                            if ($DefaultPermission == "allow") {
                                $Categories[$i]['writable'] = false;
                            }
                            else {
                                $Categories[$i]['writable'] = true;
                            }
                        }
                    }
                }
                $i++;
            }
        }
    }
}
// ===============================================================
//
//              RECUPERER LES PERMISSIONS PAR DEFAUT
//
// ===============================================================
function RetrieveDefaultPermissions()
{
	global $mysqli;
    $default_acl = "allow";
    $sql_request = "SELECT value FROM plugin_MDparams WHERE parameter = 'default_acl' ";
    if ($req = mysqli_query($mysqli, $sql_request)) {
        if ($rep = mysqli_fetch_array($req)) {
            $default_acl = $rep['value'];
        }
    }
    return $default_acl;
}
// ===============================================================
//
//              RECUPERER LES PERMISSIONS PAR DEFAUT
//
// ===============================================================
function RetrieveUserFilter()
{
	global $mysqli;
    $filter_user = "yes";
    $sql_request = "SELECT value FROM plugin_MDparams WHERE parameter = 'filter_user' ";
    if ($req = mysqli_query($mysqli, $sql_request)) {
        if ($rep = mysqli_fetch_array($req)) {
            $filter_user = $rep['value'];
        }
    }
    return $filter_user;
}
// ===============================================================
//
//              MODIFIER LES PERMISSIONS PAR DEFAUT
//
// ===============================================================
function SwapUserFilter()
{
	global $mysqli;
    $AllowAction = false;
    if ($_SESSION['statut'] == 'administrateur') {
        $AllowAction = true;
    }
    if($AllowAction) {
        $filter_user = "yes";
        $sql_request = "SELECT value FROM plugin_MDparams WHERE parameter = 'filter_user' ";
        $req = mysqli_query($mysqli, $sql_request) or die(mysqli_error($mysqli));
        if ($req) {
            if ($rep = mysqli_fetch_array($req)) {
                $filter_user = $rep['value'];
                if ($filter_user == "yes") {
                    $sql_request = "UPDATE plugin_MDparams SET value = 'no' WHERE parameter = 'filter_user'";
                }
                else {
                    $sql_request = "UPDATE plugin_MDparams SET value = 'yes' WHERE parameter = 'filter_user'";
                }
                mysqli_query($mysqli, $sql_request) or die(mysqli_error($mysqli));
            }
            else {
               $sql_request = "INSERT INTO plugin_MDparams (parameter, value) VALUES ('filter_user', 'no') ";
               mysqli_query($mysqli, $sql_request) or die(mysqli_error($mysqli));
            }
        }
        return $filter_user;
    }
}
// ===============================================================
//
//              MODIFIER LES PERMISSIONS PAR DEFAUT
//
// ===============================================================
function SwapPermissions()
{
	global $mysqli;
    $AllowAction = false;
    if ($_SESSION['statut'] == 'administrateur') {
        $AllowAction = true;
    }
    if($AllowAction) {
        $default_acl = "allow";
        $sql_request = "SELECT value FROM plugin_MDparams WHERE parameter = 'default_acl' ";
        $req = mysqli_query($mysqli, $sql_request) or die(mysqli_error($mysqli));
        if ($req) {
            if ($rep = mysqli_fetch_array($req)) {
                $default_acl = $rep['value'];
                if ($default_acl == "allow") {
                    $sql_request = "UPDATE plugin_MDparams SET value = 'deny' WHERE parameter = 'default_acl'";
                }
                else {
                    $sql_request = "UPDATE plugin_MDparams SET value = 'allow' WHERE parameter = 'default_acl'";
                }
                mysqli_query($mysqli, $sql_request) or die(mysqli_error($mysqli));
            }
            else {
               $sql_request = "INSERT INTO plugin_MDparams (parameter, value) VALUES ('default_acl', 'deny') ";
               mysqli_query($mysqli, $sql_request) or die(mysqli_error($mysqli));
            }
        }
        return $default_acl;
    }
}
// ===============================================================
//
//          MODIFIER LES PERMISSIONS D'UN GROUPE
//
// ===============================================================
function EditPermissionsGroup($id_group, &$message)
{
	global $mysqli;
    $AllowAction = false;
    if ($_SESSION['statut'] == 'administrateur') {
        $AllowAction = true;
    }
    if($AllowAction) {
        // Suppression des utilisateurs
        $sql_request = "DELETE FROM plugin_MDpermissions WHERE id_group = '".$id_group."' ";
        mysqli_query($mysqli, $sql_request) or die(mysqli_error($mysqli));

        $req_cat = mysqli_query($mysqli, "SELECT id FROM plugin_MDcategories ORDER BY id ASC") or die(mysqli_error($mysqli));

        $mychecklist = new STListBox();
        $tab_post = $mychecklist->STListBoxPost('table_cat_read');
        $i = 0;
        while (isset($tab_post[$i]))
        {
            mysqli_data_seek($req_cat,$tab_post[$i]);
            $rep_cat = mysqli_fetch_array($req_cat);
            $sql_request = "INSERT INTO plugin_MDpermissions (id_group, id_category, id_subcategory, access)
                                        VALUES ('".$id_group."', '".$rep_cat['id']."', NULL, 'read') ";
            mysqli_query($mysqli, $sql_request) or die(mysqli_error($mysqli));
            $i++;
        }

        unset($mychecklist);
        unset($table_post);

        $mychecklist = new STListBox();
        $tab_post = $mychecklist->STListBoxPost('table_cat_write');
        $i = 0;
        while (isset($tab_post[$i]))
        {
            mysqli_data_seek($req_cat,$tab_post[$i]);
            $rep_cat = mysqli_fetch_array($req_cat);
            $sql_request = "INSERT INTO plugin_MDpermissions (id_group, id_category, id_subcategory, access)
                                        VALUES ('".$id_group."', '".$rep_cat['id']."', NULL, 'write') ";
            mysqli_query($mysqli, $sql_request) or die(mysqli_error($mysqli));
            $i++;
        }

        unset($mychecklist);
        unset($table_post);

        $req_cat = mysqli_query($mysqli, "SELECT id FROM plugin_MDsubcategories ORDER BY id ASC") or die(mysqli_error($mysqli));

        $mychecklist = new STListBox();
        $tab_post = $mychecklist->STListBoxPost('table_subcat_read');
        $i = 0;
        while (isset($tab_post[$i]))
        {
            mysqli_data_seek($req_cat,$tab_post[$i]);
            $rep_cat = mysqli_fetch_array($req_cat);
            $sql_request = "INSERT INTO plugin_MDpermissions (id_group, id_category, id_subcategory, access)
                                        VALUES ('".$id_group."', NULL, '".$rep_cat['id']."', 'read') ";
            mysqli_query($mysqli, $sql_request) or die(mysqli_error($mysqli));
            $i++;
        }

        unset($mychecklist);
        unset($table_post);

        $mychecklist = new STListBox();
        $tab_post = $mychecklist->STListBoxPost('table_subcat_write');
        $i = 0;
        while (isset($tab_post[$i]))
        {
            mysqli_data_seek($req_cat,$tab_post[$i]);
            $rep_cat = mysqli_fetch_array($req_cat);
            $sql_request = "INSERT INTO plugin_MDpermissions (id_group, id_category, id_subcategory, access)
                                        VALUES ('".$id_group."', NULL, '".$rep_cat['id']."', 'write') ";
            mysqli_query($mysqli, $sql_request) or die(mysqli_error($mysqli));
            $i++;
        }

        unset($mychecklist);
        unset($table_post);
        $message = "mise à jour des permissions effectuée";
        unset($_POST['update']);
    }

}
// ===============================================================
//
//          MODIFIER LES UTILISATEURS D'UN GROUPE
//
// ===============================================================
function EditUsersGroup($id_group, &$message)
{
	global $mysqli;
    $AllowAction = false;
    if ($_SESSION['statut'] == 'administrateur') {
        $AllowAction = true;
    }
    if($AllowAction) {
        // Suppression des utilisateurs
        $sql_request = "DELETE FROM plugin_MDusers WHERE id_group = '".$id_group."' ";
        mysqli_query($mysqli, $sql_request) or die(mysqli_error($mysqli));


        $req_destinataires = mysqli_query($mysqli, "SELECT login FROM utilisateurs WHERE
                                                statut = 'administrateur' OR
                                                statut = 'professeur' OR
                                                statut = 'cpe' OR
                                                statut = 'scolarite' OR
                                                statut = 'autre' ORDER BY nom ASC") or die(mysqli_error($mysqli));

        $mychecklist = new STListBox();
        $tab_post = $mychecklist->STListBoxPost('table_mesdocs');
        $i = 0;
        while (isset($tab_post[$i]))
        {
            mysqli_data_seek($req_destinataires,$tab_post[$i]);
            $rep_destinataire = mysqli_fetch_array($req_destinataires);
            $sql_request = "INSERT INTO plugin_MDusers (id_group, login) VALUES ('".$id_group."', '".strtolower($rep_destinataire['login'])."') ";
            mysqli_query($mysqli, $sql_request) or die(mysqli_error($mysqli));
            $i++;
        }

        $message = "Mise à jour du groupe effectuée";
        unset($mychecklist);
        unset($_POST['update']);
    }

}

// ===============================================================
//
//              MODIFIER LE NOM D'UN GROUPE
//
// ===============================================================
function ModifyGroupName($id_group, $new_name, &$message)
{
	global $mysqli;
    $AllowAction = false;
    if ($_SESSION['statut'] == 'administrateur') {
        $AllowAction = true;
    }
    if($AllowAction) {
        if($id_group != NULL) {
            $sql_request = "UPDATE plugin_MDgroups SET name = '".$new_name."' WHERE id = '".$id_group."'  ";
            $req_change_name = mysqli_query($mysqli, $sql_request) or die(mysqli_error($mysqli));
            if ($req_change_name) {
                $message = "modification du nom effectuée";
            }
            else {
                $message = "Le changement de nom ne peut pas être effectué";
            }

        }
        else {
            $message = "Aucun groupe n'a été choisi";
        }
    }
    else {
        $message = "Vous tentez de réaliser une opération réservée aux administrateurs";
    }
}
// ===============================================================
//
//              RECUPERER LE NOM D'UNE CATEGORIE
//
// ===============================================================
function RetrieveGroupName($id_group)
{
	global $mysqli;
    $old_name = "";
    if ($id_group != NULL) {
        $sql_request = "SELECT name FROM plugin_MDgroups WHERE id = '".$id_group."' ";
        $req_get_name = mysqli_query($mysqli, $sql_request);
        if ($req_get_name) {
            if ($rep_get_name = mysqli_fetch_array($req_get_name)) {
                $old_name = $rep_get_name['name'];
            }
        }
    }

    return $old_name;
}
// ===============================================================
//
//                       CREER UN GROUPE
//
// ===============================================================
function CreateGroup($name_group, &$message)
{
	global $mysqli;
    $id_group = 0;
    $AllowCreation = false;
    if ($_SESSION['statut'] == 'administrateur') {
        $AllowCreation = true;
    }
    if($AllowCreation) {

        if ($name_group != NULL) {
            $sql_request = "SELECT MAX(id) FROM plugin_MDgroups";
            $req_max = mysqli_query($mysqli, $sql_request);
            if ($req_max) {
                if($rep_max = mysqli_fetch_array($req_max)) {
                    $id_group = $rep_max[0] + 1;
                }
                else {
                    $id_group = 0;
                }
            }
            else {
                $id_group = 0;
            }

            $name_group = stripslashes($name_group);
            $sql_request = "INSERT INTO plugin_MDgroups (id, name)
                                VALUES('".$id_group."','".mysqli_real_escape_string($mysqli, $name_group)."')";
            $req_insert = mysqli_query($mysqli, $sql_request);
            if (!$req_insert) {
                $message = mysqli_error($mysqli);
            }
            else {
                $message = "Le groupe a été créé avec succès";
            }

        }
        else {
            $message = "Vous devez entrer un nom de groupe";
        }
    }
    else {
        $message = "Vous tentez de créer un groupe sans en avoir le droit";
    }
    return $id_group;

}

// ===============================================================
//
//              SUPPRIMER UN GROUPE
//
// ===============================================================
function DeleteGroup($id_group,&$message)
{
	global $mysqli;
    $AllowDeletion = false;
    if ($_SESSION['statut'] == 'administrateur') {
        $AllowDeletion = true;
    }
    if($AllowDeletion) {
        if ($id_group != '1') {
            $sql_request = "DELETE FROM plugin_MDgroups WHERE id = '".mysqli_real_escape_string($mysqli, $id_group)."'";
            $req_supprimer = mysqli_query($mysqli, $sql_request);
            if (!$req_supprimer) {
                $message = "La suppression du groupe n'est pas possible - erreur 1";
            }
            $sql_request = "DELETE FROM plugin_MDusers WHERE id_group = '".mysqli_real_escape_string($mysqli, $id_group)."'";
            $req_supprimer = mysqli_query($mysqli, $sql_request);
            if (!$req_supprimer) {
                $message = "La suppression du groupe n'est pas possible - erreur 2";
            }
            $sql_request = "DELETE FROM plugin_MDpermissions WHERE id_group = '".mysqli_real_escape_string($mysqli, $id_group)."'";
            $req_supprimer = mysqli_query($mysqli, $sql_request);
            if (!$req_supprimer) {
                $message = "La suppression du groupe n'est pas possible - erreur 3";
            }
        }
        else {
            $message = "Vous ne pouvez pas supprimer le groupe 'Communauté' ";
        }
    }
}

// ===============================================================
//
//          VERIFICATION ET CREATION DES TABLES ACL
//
// ===============================================================
function VerifyAclTables()
{
	global $mysqli;
    $sql = "CREATE TABLE IF NOT EXISTS plugin_MDgroups (
            id INT,
            name CHAR(50)
            )";
    //$req_creation = mysql_query($sql) or die(mysql_error());
	$req_creation = mysqli_query($mysqli, $sql) or die(mysqli_error($mysqli));	
	
    $sql = "CREATE TABLE IF NOT EXISTS plugin_MDusers (
            id_group INT,
            login CHAR(100)
            )";
    //$req_creation = mysql_query($sql) or die(mysql_error());
	$req_creation = mysqli_query($mysqli, $sql) or die(mysqli_error($mysqli));	
	
    $sql = "CREATE TABLE IF NOT EXISTS plugin_MDpermissions (
            id_group INT,
            id_category INT,
            id_subcategory INT,
            access CHAR(50)
            )";
    //$req_creation = mysql_query($sql) or die(mysql_error());
	$req_creation = mysqli_query($mysqli, $sql) or die(mysqli_error($mysqli));
}

// ===============================================================
//
//          VERIFIER LA TABLE plugin_MDusers
//
// ===============================================================
function VerifyAclUsersTable()
{
	global $mysqli;
    $sql_request = "SELECT login FROM plugin_MDusers WHERE login NOT IN (SELECT login FROM utilisateurs)";
    if ($req_logins = mysqli_query($mysqli, $sql_request)) {
        if (mysqli_num_rows($req_logins) != 0) {
            $sql_request = "DELETE FROM plugin_MDusers WHERE login NOT IN (SELECT login FROM utilisateurs)";
            mysqli_query($mysqli, $sql_request);
        }
    }
}
// ===============================================================
//
//          VERIFIER LA TABLE plugin_MDpermissions
//
// ===============================================================
function VerifyAclPermissionsTable()
{
	global $mysqli;
    $sql_request = "SELECT id_category FROM plugin_MDpermissions WHERE id_category NOT IN (SELECT id FROM plugin_MDcategories) AND id_category NOT NULL";
    if ($req = mysqli_query($mysqli, $sql_request)) {
        if (mysqli_num_rows($req) != 0) {
            $sql_request = "DELETE FROM plugin_MDpermissions WHERE id_category NOT IN (SELECT id FROM plugin_MDcategories) AND id_category NOT NULL";
            mysqli_query($mysqli, $sql_request);
        }
    }
    $sql_request = "SELECT id_subcategory FROM plugin_MDpermissions WHERE id_subcategory NOT IN (SELECT id FROM plugin_MDsubcategories) AND id_subcategory NOT NULL";
    if ($req = mysqli_query($mysqli, $sql_request)) {
        if (mysqli_num_rows($req) != 0) {
            $sql_request = "DELETE FROM plugin_MDpermissions WHERE id_subcategory NOT IN (SELECT id FROM plugin_MDsubcategories) AND id_subcategory NOT NULL";
            mysqli_query($mysqli, $sql_request);
        }
    }

}
// ===============================================================
//
//              RECUPERER LES GROUPES
//
// ===============================================================
function RetrieveGroups(&$Groups, &$message)
{
	global $mysqli;

    $sql_request = "SELECT id, name FROM plugin_MDgroups ORDER BY name ASC";
    $req_groups = mysqli_query($mysqli, $sql_request);
    $i = 0;
    if ($req_groups) {
        while ($rep_groups = mysqli_fetch_array($req_groups)) {
            $Groups[$i]['id'] = $rep_groups['id'];
            $Groups[$i]['name'] = $rep_groups['name'];
            $i++;
        }
    }
    return $i;

}
// ===============================================================
//
//              RECUPERER LES UTILISATEURS D'UN GROUPE
//
// ===============================================================
function RetrieveUsersFromGroup($id_group)
{
	global $mysqli;
    $Users = array();
    $sql_request = "SELECT login FROM plugin_MDusers WHERE id_group = '".$id_group."' ";
    $req_users = mysqli_query($mysqli, $sql_request);
    $i = 0;
    if ($req_users) {
        while ($rep_users = mysqli_fetch_array($req_users)) {
            $Users[$i] = strtolower($rep_users['login']);
            $i++;
        }
    }
    return $Users;

}

// ===============================================================
//
//              RECUPERER LES CATEGORIES D'UN GROUPE
//
// ===============================================================
function RetrieveCategoriesFromGroup($id_group, $access)
{
	global $mysqli;

    $Categories = array();
    $sql_request = "SELECT id FROM plugin_MDcategories WHERE
                                    id IN (SELECT id_category FROM plugin_MDpermissions WHERE
                                                                id_group = '".$id_group."' AND
                                                                access = '".$access."' 
                                                                 )";

    $req_categories = mysqli_query($mysqli, $sql_request) or die(mysqli_error($mysqli));
    $i = 0;
    if ($req_categories) {
        while ($rep_categories = mysqli_fetch_array($req_categories)) {
            $Categories[$i] = $rep_categories['id'];
            $i++;
        }
    }
   
    return $Categories;

}
// ===============================================================
//
//              RECUPERER LES SOUS-CATEGORIES D'UN GROUPE
//
// ===============================================================
function RetrieveSubCategoriesFromGroup($id_group, $access)
{
    $Categories = array();
    $sql_request = "SELECT id FROM plugin_MDsubcategories WHERE
                                    id IN (SELECT id_subcategory FROM plugin_MDpermissions WHERE
                                                                id_group = '".$id_group."' AND
                                                                access = '".$access."' )
                                                                ";
    $req_categories = mysqli_query($mysqli, $sql_request);
    $i = 0;
    if ($req_categories) {
        while ($rep_categories = mysqli_fetch_array($req_categories)) {
            $Categories[$i] = $rep_categories['id'];
            $i++;
        }
    }
    return $Categories;

}
?>