<?php
/**
 * Fichier CategoriesManagement.php pour gérer des documents
 *
 *
 * Copyright 2010 Pascal Fautrero
 *
 * This file is part of MesDocuments, a plugin for GEPI.
 *
 * GEPI is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * MesDocuments is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with GEPI; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
// function ModifyCategoryName($id_category, $id_subcategory, $new_name, $message)
// function RetrieveCategoryName($id_category, $id_subcategory)
// function DeleteCategoryFromDatabase($id_category,&$message)
// function DeleteSubCategoryFromDatabase($id_subcategory,&$message)
// function CreateNewCategoryInDatabase($name_folder, &$message)
// function CreateNewSubCategoryInDatabase($name_subcategory, $id_category, &$message)
// function RetrieveCategories(&$Categories, &$message)
// function RetrieveSubCategories(&$SubCategories, $id_category, $message)
// ===============================================================
//
//              MONTER LA CATEGORIE COURANTE D'UN RANG
//
// ===============================================================
function MoveUp($id_category, $table, &$message)
{
	global $mysqli;
    $AllowAction = false;
    if ($_SESSION['statut'] == 'administrateur') {
        $AllowAction = true;
    }
    if($AllowAction) {
        $sql_request = "";
        if ($table == "plugin_MDcategories") {
            $sql_request = "SELECT rank FROM ".$table." WHERE id = '".$id_category."' ";

        }
        else if ($table == "plugin_MDsubcategories") {
            $sql_request = "SELECT rank , id_category FROM ".$table." WHERE id = '".$id_category."' ";

        }
        if ($req_rank = mysqli_query($mysqli, $sql_request)) {
            if ($rep_rank = mysqli_fetch_array($req_rank)) {
                $current_rank = $rep_rank['rank'];
                $previous_rank = $rep_rank['rank'] - 1;
                $sql_request = "";
                if ($table == 'plugin_MDcategories') {
                    $sql_request = "SELECT id FROM ".$table." WHERE rank = '".$previous_rank."' ";

                }
                else if ($table == 'plugin_MDsubcategories') {
                    $sql_request = "SELECT id FROM ".$table." WHERE rank = '".$previous_rank."' AND id_category = '".$rep_rank['id_category']."' ";

                }
                if ($req_rank = mysqli_query($mysqli, $sql_request)) {
                    if ($rep_rank = mysqli_fetch_array($req_rank)) {
                        $sql_request = "UPDATE ".$table." SET rank = '".$current_rank."' WHERE id = '".$rep_rank['id']."' ";
                        mysqli_query($mysqli, $sql_request);
                        $sql_request = "UPDATE ".$table." SET rank = '".$previous_rank."' WHERE id = '".$id_category."' ";
                        mysqli_query($mysqli, $sql_request);
                    }
                }
            }
        }
    }
    else {
        $message = "Vous tentez de réaliser une opération réservée aux administrateurs";
    }
}
// ===============================================================
//
//              DESCENDRE LA CATEGORIE COURANTE D'UN RANG
//
// ===============================================================
function MoveDown($id_category, $table, &$message)
{
	global $mysqli;
    $AllowAction = false;
    if ($_SESSION['statut'] == 'administrateur') {
        $AllowAction = true;
    }
    if($AllowAction) {
        $sql_request = "";
        if ($table == 'plugin_MDcategories') {
            $sql_request = "SELECT rank FROM ".$table." WHERE id = '".$id_category."' ";
        }
        else if ($table == 'plugin_MDsubcategories') {
            $sql_request = "SELECT rank , id_category FROM ".$table." WHERE id = '".$id_category."' ";
        }
        if ($req_rank = mysqli_query($mysqli, $sql_request)) {
            if ($rep_rank = mysqli_fetch_array($req_rank)) {
                $current_rank = $rep_rank['rank'];
                $next_rank = $rep_rank['rank'] + 1;
                $sql_request = "";
                if ($table == 'plugin_MDcategories') {
                    $sql_request = "SELECT id FROM ".$table." WHERE rank = '".$next_rank."' ";
                }
                else if ($table == 'plugin_MDsubcategories') {
                    $sql_request = "SELECT id FROM ".$table." WHERE rank = '".$next_rank."' AND id_category = '".$rep_rank['id_category']."' ";
                }
                if ($req_rank = mysqli_query($mysqli, $sql_request)) {
                    if ($rep_rank = mysqli_fetch_array($req_rank)) {
                        $sql_request = "UPDATE ".$table." SET rank = '".$current_rank."' WHERE id = '".$rep_rank['id']."' ";
                        mysqli_query($mysqli, $sql_request);
                        $sql_request = "UPDATE ".$table." SET rank = '".$next_rank."' WHERE id = '".$id_category."' ";
                        mysqli_query($mysqli, $sql_request);
                    }
                }
            }
        }
    }
    else {
        $message = "Vous tentez de réaliser une opération réservée aux administrateurs";
    }
}
// ===============================================================
//
//              RECUPERER LA CATEGORIE PAR DEFAUT
//
// ===============================================================
function GetDefaultCategory()
{
	global $mysqli;
    $default_category = 0;
    $sql_request = "SELECT value FROM plugin_MDparams WHERE parameter = 'default_category' ";
    if ($req_default_category = mysqli_query($mysqli, $sql_request)) {
        if ($rep_default_category = mysqli_fetch_array($req_default_category)) {
            $default_category = $rep_default_category['value'];
        }
    }
    return $default_category;
}

// ===============================================================
//
//              DEFINIR LA CATEGORIE PAR DEFAUT
//
// ===============================================================
function SetDefaultCategory($id_category, &$message)
{
	global $mysqli;
    $AllowAction = false;
    if ($_SESSION['statut'] == 'administrateur') {
        $AllowAction = true;
    }
    if($AllowAction) {
        $default_category = 0;
        $sql_request = "SELECT value FROM plugin_MDparams WHERE parameter = 'default_category' ";
        if ($req_default_category = mysqli_query($mysqli, $sql_request)) {
            if ($rep_default_category = mysqli_fetch_array($req_default_category)) {
                $sql_request = "UPDATE plugin_MDparams SET value = '".$id_category."' WHERE parameter = 'default_category'  ";
            }
            else {
                $sql_request = "INSERT INTO plugin_MDparams (parameter, value) VALUES ('default_category', '".$id_category."') ";
            }
        }
        if (!mysqli_query($mysqli, $sql_request)) {
            $message = mysqli_error($mysqli);
        }
    }
    else {
        $message = "Vous tentez de réaliser une opération réservée aux administrateurs";
    }

}

// ===============================================================
//
//              MODIFIER LE NOM D'UNE CATEGORIE
//
// ===============================================================
function ModifyCategoryName($id_category, $id_subcategory, $new_name, &$message)
{
	global $mysqli;
    $AllowAction = false;
    if ($_SESSION['statut'] == 'administrateur') {
        $AllowAction = true;
    }
    if($AllowAction) {
        if($id_category != NULL) {
            $sql_request = "UPDATE plugin_MDcategories SET name = '".$new_name."' WHERE id = '".$id_category."'  ";
            $req_change_name = mysqli_query($mysqli, $sql_request) or die(mysqli_error($mysqli));
            if ($req_change_name) {
                $message = "modification du nom effectuée";
            }
            else {
                $message = "Le changement de nom ne peut pas être effectué";
            }

        }
        else if ($id_subcategory != NULL) {
            $sql_request = "UPDATE plugin_MDsubcategories SET name = '".$new_name."' WHERE id = '".$id_subcategory."'  ";
            $req_change_name = mysqli_query($mysqli, $sql_request) or die(mysqli_error($mysqli));
            if ($req_change_name) {
                $message = "modification du nom effectuée";
            }
            else {
                $message = "Le changement de nom ne peut pas être effectué";
            }
        }
        else {
            $message = "Aucune catégorie n'a été choisie";
        }
    }
    else {
        $message = "Vous tentez de réaliser une opération réservée aux administrateurs";
    }
}
// ===============================================================
//
//              RECUPERER LE NOM D'UNE CATEGORIE
//
// ===============================================================
function RetrieveCategoryName($id_category, $id_subcategory)
{
	global $mysqli;
    $old_name = "";
    if ($id_category != NULL) {
        $sql_request = "SELECT name FROM plugin_MDcategories WHERE id = '".$id_category."' ";
        $req_get_name = mysqli_query($mysqli, $sql_request);
        if ($req_get_name) {
            if ($rep_get_name = mysqli_fetch_array($req_get_name)) {
                $old_name = $rep_get_name['name'];
            }
        }
    }
    else if ($id_subcategory != NULL) {
        $sql_request = "SELECT name FROM plugin_MDsubcategories WHERE id = '".$id_subcategory."' ";
        $req_get_name = mysqli_query($mysqli, $sql_request);
        if ($req_get_name) {
            if ($rep_get_name = mysqli_fetch_array($req_get_name)) {
                $old_name = $rep_get_name['name'];
            }
        }
    }

    return $old_name;
}
// ===============================================================
//
//              RECUPERER L'ID D'UNE SOUS-CAT A PARTIR DU DOC
//
// ===============================================================
function RetrieveSubCategoryFromDoc($filename)
{
	global $mysqli;
    $id = "";
    if ($filename != NULL) {
        $sql_request = "SELECT directory FROM plugin_MDdocs WHERE filename = '".$filename."' ";
        $req_get_id = mysqli_query($mysqli, $sql_request);
        if ($req_get_id) {
            if ($rep_get_id = mysqli_fetch_array($req_get_id)) {
                $id = $rep_get_id['directory'];
            }
        }
    }
    return $id;
}
// ===============================================================
//
//              RECUPERER L'ID D'UNE SOUS-CAT A PARTIR DU DOC
//
// ===============================================================
function RetrieveSubCategoryFromLink($id_link)
{
	global $mysqli;
    $id = "";
    if ($id_link != NULL) {
        $sql_request = "SELECT directory FROM plugin_MDlinks WHERE id = '".$id_link."' ";
        $req_get_id = mysqli_query($mysqli, $sql_request);
        if ($req_get_id) {
            if ($rep_get_id = mysqli_fetch_array($req_get_id)) {
                $id = $rep_get_id['directory'];
            }
        }
    }
    return $id;
}
// ===============================================================
//
//              VERIFIER L'EXISTENCE D'UNE CATEGORIE
//
// ===============================================================
function InvalidCategory($id)
{
	global $mysqli;
    $default_id = true;
    $sql_request = "SELECT id FROM plugin_MDcategories WHERE id = '".$id."'";
    if ($req_id = mysqli_query($mysqli, $sql_request)) {
        if ($rep_id = mysqli_fetch_array($req_id)) {
            $default_id = false;
        }
    }
    return $default_id;
}
// ===============================================================
//
//              RECUPERER ID DE LA PREMIERE CATEGORIE
//
// ===============================================================
function RetrieveIDFirstCategory()
{
	global $mysqli;
    $default_id = 0;
    $sql_request = "SELECT id FROM plugin_MDcategories";
    if ($req_id = mysqli_query($mysqli, $sql_request)) {
        if ($rep_id = mysqli_fetch_array($req_id)) {
            $default_id = $rep_id['id'];
        }
    }
    return $default_id;
}
// ===============================================================
//
//              SUPPRIMER UNE CATEGORIE
//
// ===============================================================
function DeleteCategoryFromDatabase($id_category,&$message)
{
	global $mysqli;
    $AllowDeletion = false;
    if ($_SESSION['statut'] == 'administrateur') {
        $AllowDeletion = true;
    }
    if($AllowDeletion) {
        $sql_request = "SELECT id FROM plugin_MDsubcategories WHERE id_category = '".mysqli_real_escape_string($mysqli, $id_category)."'";
        $req_subcategories = mysqli_query($mysqli, $sql_request);
        if ($req_subcategories) {

            if (mysqli_num_rows($req_subcategories) == 0) {
                $sql_request = "DELETE FROM plugin_MDcategories WHERE id = '".mysqli_real_escape_string($mysqli, $id_category)."'";
                $req_supprimer = mysqli_query($mysqli, $sql_request);
                if (!$req_supprimer) {
                    $message = "La suppression n'est pas possible";
                }
                else {
                    if (GetDefaultCategory() == $id_category){
                        SetDefaultCategory(RetrieveIDFirstCategory(), $message);
                    }
                    $message = "La catégorie a été supprimée avec succès";
                }
            }
            else {
				echo mysqli_num_rows($req_subcategories)." req_subcategories";
                $message = "La catégorie que vous essayez de supprimer contient des sous-catégories. Supprimez-les d'abord";
            }
        }
        else {
            $message = mysqli_error($mysqli);
        }
    }
    else {
        $message = "Vous tentez de supprimer une catégorie sans en avoir le droit";
    }

}
// ===============================================================
//
//              SUPPRIMER UNE SOUS-CATEGORIE
//
// ===============================================================
function DeleteSubCategoryFromDatabase($id_subcategory,&$message)
{
	global $mysqli;
    $AllowDeletion = false;
    if ($_SESSION['statut'] == 'administrateur') {
        $AllowDeletion = true;
    }
    if($AllowDeletion) {
        $sql_request = "SELECT filename FROM plugin_MDdocs WHERE directory = '".mysqli_real_escape_string($mysqli, $id_subcategory)."'";
        $req_docs = mysqli_query($mysqli, $sql_request);
        if ($req_docs) {

            if (mysqli_num_rows($req_docs) == 0) {
                $sql_request = "DELETE FROM plugin_MDsubcategories WHERE id = '".mysqli_real_escape_string($mysqli, $id_subcategory)."'";
                $req_supprimer = mysqli_query($mysqli, $sql_request);
                if (!$req_supprimer) {
                    $message = "La suppression n'est pas possible";
                }
                else {
                    $message = "La sous-catégorie a été supprimée avec succès";
                }
            }
            else {
                $message = "La sous-catégorie que vous essayez de supprimer contient des documents. Supprimez-les d'abord";
            }
        }
        else {
            $message = mysqli_error($mysqli);
        }
    }
    else {
        $message = "Vous tentez de supprimer une sous-categorie sans en avoir le droit";
    }

}
// ===============================================================
//
//                       CREER UNE CATEGORIE
//
// ===============================================================
function CreateNewCategoryInDatabase($name_folder, &$message)
{
	global $mysqli;
    $id_folder = 0;
    $AllowCreation = false;
    if ($_SESSION['statut'] == 'administrateur') {
        $AllowCreation = true;
    }
    if($AllowCreation) {

        if ($name_folder != NULL) {
            $sql_request = "SELECT MAX(id) FROM plugin_MDcategories";
            $req_max = mysqli_query($mysqli, $sql_request);
            if ($req_max) {
                if($rep_max = mysqli_fetch_array($req_max)) {
                    $id_folder = $rep_max[0] + 1;
                }
                else {
                    $id_folder = 0;
                }
            }
            else {
                $id_folder = 0;
            }
            $sql_request = "SELECT MAX(rank) FROM plugin_MDcategories";
            $req_max = mysqli_query($mysqli, $sql_request);
            if ($req_max) {
                if($rep_max = mysqli_fetch_array($req_max)) {
                    $rank = $rep_max[0] + 1;
                }
                else {
                    $rank = 0;
                }
            }
            else {
                $rank = 0;
            }
            $name_folder = stripslashes($name_folder);
            $sql_request = "INSERT INTO plugin_MDcategories (id, name, rank)
                                VALUES('".$id_folder."','".mysqli_real_escape_string($mysqli, $name_folder)."', $rank)";
            $req_insert = mysqli_query($mysqli, $sql_request);
            if (!$req_insert) {
                $message = mysqli_error($mysqli);
            }
            else {
                $message = "La catégorie a été créée avec succès";
            }

        }
        else {
            $message = "Vous devez entrer un nom de catégorie";
        }
    }
    else {
        $message = "Vous tentez de créer une catégorie sans en avoir le droit";
    }
    return $id_folder;

}

// ===============================================================
//
//                       CREER UNE SOUS-CATEGORIE
//
// ===============================================================
function CreateNewSubCategoryInDatabase($name_subcategory, $id_category, &$message)
{
	global $mysqli;

    $AllowCreation = false;
    if ($_SESSION['statut'] == 'administrateur') {
        $AllowCreation = true;
    }
    if (!InvalidCategory($id_category)) {
        if($AllowCreation) {
            if ($name_subcategory != NULL) {

                $sql_request = "SELECT MAX(id) FROM plugin_MDsubcategories ";
                $req_max = mysqli_query($mysqli, $sql_request);
                if ($req_max) {
                    if($rep_max = mysqli_fetch_array($req_max)) {
                        $id_subcategory = $rep_max[0] + 1;
                    }
                    else {
                        $id_subcategory = 0;
                    }
                }
                else {
                    $id_subcategory = 0;
                }
                $sql_request = "SELECT MAX(rank) FROM plugin_MDsubcategories WHERE id_category = '".$id_category."'";
                $req_max = mysqli_query($mysqli, $sql_request);
                if ($req_max) {
                    if($rep_max = mysqli_fetch_array($req_max)) {
                        $rank = $rep_max[0] + 1;
                    }
                    else {
                        $rank = 0;
                    }
                }
                else {
                    $rank = 0;
                }
                $name_subcategory = stripslashes($name_subcategory);
                $sql_request = "INSERT INTO plugin_MDsubcategories (id, id_category, name, rank)
                                    VALUES('".$id_subcategory."','".$id_category."','".mysqli_real_escape_string($mysqli, $name_subcategory)."', $rank)";
                $req_insert = mysqli_query($mysqli, $sql_request);
                if (!$req_insert) {
                    $message = mysqli_error($mysqli);
                }
                else {
                    $message = "La sous-catégorie a été créée avec succès";
                }

            }
            else {
                $message = "Vous devez entrer un nom de sous-catégorie";
            }
        }
        else {
            $message = "Vous tentez de créer une sous-catégorie sans en avoir le droit";
        }
    }
    else {
        $message = "Vous tentez de créer une sous-catégorie dans une catégorie inexistante";
    }
}
// ===============================================================
//
//              RECUPERER LES CATEGORIES
//
// ===============================================================
function RetrieveCategories(&$Categories, &$message)
{
	global $mysqli;

    $sql_request = "SELECT id, name FROM plugin_MDcategories ORDER BY rank ASC";
    $req_dossiers = mysqli_query($mysqli, $sql_request);
    $i = 0;
    if ($req_dossiers) {
        while ($rep_dossiers = mysqli_fetch_array($req_dossiers)) {
            $Categories[$i]['id'] = $rep_dossiers['id'];
            $Categories[$i]['name'] = $rep_dossiers['name'];
            if (GetDefaultCategory() == $Categories[$i]['id']) {
                $Categories[$i]['default'] = true;
            }
            else {
                $Categories[$i]['default'] = false;
            }
            $i++;
        }
        RetrieveUserPermissions($Categories, strtolower($_SESSION['login']));
    }
    return $i;

}

// ===============================================================
//
//              RECUPERER LES SOUS-CATEGORIES
//
// ===============================================================
function RetrieveSubCategories(&$SubCategories, $id_category, $message)
{
	global $mysqli;
    $sql_request = "SELECT id, name FROM plugin_MDsubcategories WHERE id_category='".$id_category."' ORDER BY rank ASC";
    $req_subcategories = mysqli_query($mysqli, $sql_request);
    $i = 0;
    if ($req_subcategories) {
        while ($rep_subcategories = mysqli_fetch_array($req_subcategories)) {
            $SubCategories[$i]['id'] = $rep_subcategories['id'];
            $SubCategories[$i]['name'] = $rep_subcategories['name'];
            $i++;
        }
        RetrieveUserPermissionsSubCategories($SubCategories, strtolower($_SESSION['login']));
    }
    return $i;

}

?>