<?php

/**
 * Fichier upload.php pour gérer des documents
 *
 *
 * Copyright 2010-2014 Pascal Fautrero, Bouguin Régis
 *
 * This file is part of MesDocuments, a plugin for GEPI.
 *
 * GEPI is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * MesDocuments is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with GEPI; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

$titre_page = "Mes Documents";
$affiche_connexion = 'yes';
$niveau_arbo = "2";


// ===============================================================
//
//                  IMPORTATION DES FONCTIONS ET CLASSES
//
// ===============================================================
include("./includes.php");

// ===============================================================
//
//                  INITIALISATION DES DONNEES
//
// ===============================================================

$upload=isset($_GET['upload']) ? $_GET['upload'] : (isset($_POST['upload']) ? $_POST['upload'] : NULL);
$id_subcategory=isset($_GET['id_subcategory']) ? $_GET['id_subcategory'] : (isset($_POST['id_subcategory']) ? $_POST['id_subcategory'] : NULL);
$description=isset($_GET['description']) ? $_GET['description'] : (isset($_POST['description']) ? $_POST['description'] : NULL);
$description_details=isset($_GET['description_details']) ? $_GET['description_details'] : (isset($_POST['description_details']) ? $_POST['description_details'] : NULL);
$dirpath  =  RetrieveFolder();  
$message = "";
$file_name = "";
$file_size = 0;
$file_date = 0;
$style_specifique = "/mod_plugins/MesDocuments/views/style_mesdocuments";
$tab = array();
$Categories = array();
$nbCategories = 0;
$mychecklist = array();
$txtItem = array();
$checkedlist = array();

// TESTS DE SECURITE
$resultat_session = $session_gepi->security_check();
if ($resultat_session == 'c') {
	header("Location: ../utilisateurs/mon_compte.php?change_mdp=yes");
	die();
} else if ($resultat_session == '0') {
	header("Location: ../logout.php?auto=1");
	die();
}

if (CurrentUserIsAllowed()) {
    if (CategoryWritable(RetrieveCategoryFromSubCategory($id_subcategory), strtolower($_SESSION['login']))) {
        if (SubCategoryWritable($id_subcategory, strtolower($_SESSION['login']))) {
            $AllowAccessPage = true;
			
            // TEST SUR LE DOSSIER DE STOCKAGE
            if (!is_dir($dirpath)) {
                CreateDirectory($dirpath);
                CreateProtectionFile();
            }
            // CREATION DE LA LISTBOX
            PrepareListBoxDatas($tab, $checkedlist, $id_subcategory);
            $mychecklist = CreateListBox($tab, $checkedlist);
			
			$FilterAtUserLevel = RetrieveUserFilter();
            // Récupérer les statuts de GEPI pour la listbox
            $txtItem = RetrieveUsersStatus();

            // GESTION DE L'UPLOAD
            if ($upload != NULL) {
                if (UploadFile($upload, $file_name, $file_size, $file_date, $message)) {
                    InsertDocumentInDatabase($file_name, $file_size, $file_date, $description, $id_subcategory, $description_details);
                }
             }
        }
        else {
            $AllowAccessPage = false;
        }
    }
    else {
        $AllowAccessPage = false;
    }

    // RECUPERATION DES CATEGORIES (POUR LE MENU)
    $nbCategories = RetrieveCategories($Categories, $message);

    // Tester la présence de IE6
    $IE6 = DetectIE6();

    // Formatter la taille maxi
    $maximumsize = FormatMaxSize();

    // Définir les droits d'accès au menu admin
    $AllowAdminMenu = DefineAdminMenuPermission();

    // Définir le menu sélectionné
    $menu_item = "";

    // ===============================================================
    //
    //                              VUE
    //
    // ===============================================================

    require_once("../../lib/header.inc.php");
    DisplayUploadView($message, $Categories, $nbCategories, $IE6, $AllowAdminMenu, $mychecklist, $maximumsize, $id_subcategory, $txtItem, $menu_item, $AllowAccessPage, $FilterAtUserLevel);
    require_once("../../lib/footer.inc.php");
}
else {
    // ===============================================================
    //
    //                              VUE
    //
    // ===============================================================

    require_once("../../lib/header.inc.php");
    DisplayDenyAccess();
    require_once("../../lib/footer.inc.php");
}
?>