<?php

/**
 * Fichier help_view.php pour gérer des documents
 *
 * Copyright 2010 Pascal Fautrero
 *
 * beta-testers : Didier Blanqui, Régis Bouguin
 *
 * This file is part of MesDocuments, a plugin for GEPI.
 *
 * GEPI is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * MesDocuments is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with GEPI; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

include('menu.php');
echo "<div class=\"contenu\">";

if ($AllowAdminMenu) {
    if ($message != "") {
        echo "<div class=\"cadreInformation\">".$message."</div>";
    }
    
    if (!$IE6) {
        echo("<div class=\"fond\">
		    <div class=\"coingh\"></div>
            <div class=\"coindh\"></div>
            <div class=\"partiecentralehaut\"></div>
            <div class=\"droite\"></div>
            <div class=\"gauche\"></div>
            <div class=\"coingb\"></div>
		    <div class=\"coindb\"></div>
		    <div class=\"partiecentralebas\"></div>\n");
    }      
    echo "<h3>Principe</h3>";
    echo "<p>Ce plugin vous permet de déposer et de partager des <strong>documents</strong> ou des <strong>liens</strong> dans GEPI. Ces documents peuvent être organisés dans une arborescence à deux niveaux. </p>";
    echo "<p>Le premier niveau est constitué de catégories qui vont contenir à un second niveau des sous-catégories. A leur tour, ces sous-catégories serviront pour héberger les documents et liens à partager.</p>";
    echo "<div style=\"text-align:center;\"><img src=\"./views/images/arbre.png\" /></div>";
     if (!$IE6) {
        echo "</div><br/>";
    }
    if (!$IE6) {
        echo("<div class=\"fond\">
		    <div class=\"coingh\"></div>
            <div class=\"coindh\"></div>
            <div class=\"partiecentralehaut\"></div>
            <div class=\"droite\"></div>
            <div class=\"gauche\"></div>
            <div class=\"coingb\"></div>
		    <div class=\"coindb\"></div>
		    <div class=\"partiecentralebas\"></div>\n");
    }      
    echo "<h3>Démarrage rapide</h3>";
    echo "<p>Dès l'ouverture de MesDocuments, vous disposez d'une catégorie appelée \"Mes Documents\" dans laquelle il y a déjà une sous-catégorie appelée \"Liste des ressources\". Vous pouvez dès lors y déposer des documents ou des liens en cliquant sur \"Ajouter un document\" ou \"Ajouter un lien\".</p>";
     if (!$IE6) {
        echo "</div><br/>";
    }
    if (!$IE6) {
        echo("<div class=\"fond\">
		    <div class=\"coingh\"></div>
            <div class=\"coindh\"></div>
            <div class=\"partiecentralehaut\"></div>
            <div class=\"droite\"></div>
            <div class=\"gauche\"></div>
            <div class=\"coingb\"></div>
		    <div class=\"coindb\"></div>
		    <div class=\"partiecentralebas\"></div>\n");
    }
    echo "<h3>Création d'une catégorie</h3>";
    echo "<p>Pour créer une nouvelle catégorie, il n'y a rien de plus simple : </p>";
    echo "<br/>";
    echo "<p><strong>1</strong>. Dans le menu de gauche, cliquez sur \"Gestion des catégories\" et créez votre première catégorie. Dès qu'elle est créée, vous la voyez apparaître dans le menu de gauche. </p>";
    echo "<br/>";
    echo "<p><strong>2</strong>. Cliquez alors sur ce nouveau lien. Vous y voyez alors une première sous-catégorie intitulée \"Liste des ressources\" qui a été créée automatiquement au moment de la création de la catégorie.</p>";
    echo "<br/>";
    echo "<p><strong>3</strong>. Les utilisateurs de GEPI peuvent commencer à déposer leurs ressources en sélectionnant la catégorie dans le menu de gauche et en cliquant sur \"Ajouter un document\" ou \"Ajouter un lien\".</p>";
     if (!$IE6) {
        echo "</div><br/>";
    }
    if (!$IE6) {
        echo("<div class=\"fond\">
		    <div class=\"coingh\"></div>
            <div class=\"coindh\"></div>
            <div class=\"partiecentralehaut\"></div>
            <div class=\"droite\"></div>
            <div class=\"gauche\"></div>
            <div class=\"coingb\"></div>
		    <div class=\"coindb\"></div>
		    <div class=\"partiecentralebas\"></div>\n");
    }
    echo "<h3>Gestion des catégories</h3>";
    echo "<p>Vous avez quelques options pratiques disponibles pour organiser vos catégories et sous-catégories. </p>";
    echo "<br/>";
    echo "<p><strong>Classement : </strong> Par défaut, les catégories et sous-catégories sont affichées à l'écran dans l'ordre de leur création. Vous pouvez les réordonner comme bon vous semble en allant dans 'Gestion des catégories' et en jouant sur les petites flèches bleues. </p>";
    echo "<br/>";
    echo "<p><strong>Catégorie d'ouverture : </strong> Quand un utilisateur ouvre 'Mes Documents', il voit apparaître le contenu d'une catégorie. Par défaut, il s'agit de la catégorie 'Mes Documents'. Néanmoins, vous pouvez décider de choisir une autre catégorie d'ouverture. Il suffit de cocher la petite case adéquate dans 'Gestion des catégories'.</p>";
    echo "<br/>";
    echo "<p><strong>Renommer : </strong> Les catégories et sous-catégories peuvent être renommées même si elles contiennent déjà des ressources. Pour cela, il suffit de cliquer sur le petit crayon situé à côté du nom de la catégorie visée.</p>";
     if (!$IE6) {
        echo "</div><br/>";
    }
    if (!$IE6) {
        echo("<div class=\"fond\">
		    <div class=\"coingh\"></div>
            <div class=\"coindh\"></div>
            <div class=\"partiecentralehaut\"></div>
            <div class=\"droite\"></div>
            <div class=\"gauche\"></div>
            <div class=\"coingb\"></div>
		    <div class=\"coindb\"></div>
		    <div class=\"partiecentralebas\"></div>\n");
    }
    echo "<h3>Gestion des droits : principe</h3>";
    echo "<p>Par défaut, tous les documents sont accessibles à tous les personnels de votre établissement. Ceci signifie que tout le monde a accès aux documents et liens déposés. Néanmoins, moyennant quelques paramétrages, vous pouvez contrôler l'accès à ces ressources à trois niveaux.</p>";
    echo "<br/>";
    echo "<p><strong>Niveau 1</strong>. Vous pouvez interdire l'accès à une catégorie et toutes ses sous-catégories en lecture ou en écriture pour certains utilisateurs. </p>";
    echo "<br/>";
    echo "<p><strong>Niveau 2</strong>. Vous pouvez interdire l'accès à une sous-catégorie en lecture ou en écriture pour certains utilisateurs.</p>";
    echo "<br/>";
    echo "<p><strong>Niveau 3</strong>. Les utilisateurs de GEPI peuvent restreindre l'accès à leurs documents à certains utilisateurs. Toutes interdictions de niveau 1 ou 2 entrainent une interdiction de niveau 3.</p>";
     if (!$IE6) {
        echo "</div><br/>";
    }
    if (!$IE6) {
        echo("<div class=\"fond\">
		    <div class=\"coingh\"></div>
            <div class=\"coindh\"></div>
            <div class=\"partiecentralehaut\"></div>
            <div class=\"droite\"></div>
            <div class=\"gauche\"></div>
            <div class=\"coingb\"></div>
		    <div class=\"coindb\"></div>
		    <div class=\"partiecentralebas\"></div>\n");
    }
    echo "<h3>Gestion des droits : Novices</h3>";
    echo "<p>Les contrôles d'accès de niveau 1 et 2 sont réalisables non pas sur des utilisateurs particuliers mais sur des groupes d'utilisateurs identifiés. Un groupe est un ensemble d'utilisateurs pour lequel certaines catégories sont interdites. Par défaut, il existe déjà un groupe appelé 'communauté' dans lequel sont inscrits automatiquement tous les utilisateurs si ces derniers ne sont pas déjà affectés dans un groupe. Prenons un exemple simple. Un soir de pluie sans brouillard, vous décidez de créer une catégorie 'espace administrateurs' et vous souhaitez restreindre son accès aux seuls administrateurs de GEPI. Pour cela, rien de plus simple.</p>";
    echo "<br/>";
    echo "<p><strong>Etape 1</strong>. Vous créez un groupe que vous appelez 'administrateurs GEPI' (Pour cela, allez dans Gestion des groupes)</p>";
    echo "<br/>";
    echo "<p><strong>Etape 2</strong>. Vous y faites figurer tous les administrateurs. (Toujours dans gestion des groupes, cliquez sur le petit icône 'éditer les utilisateurs' en face de votre groupe fraichement créé) </p>";
    echo "<br/>";
    echo "<p><strong>Etape 3</strong>. Vérifiez que les administrateurs GEPI ne sont pas déjà inscrits dans le groupe 'Communauté'. Le cas échéant, supprimez-les de ce dernier groupe.</p>";
    echo "<br/>";
    echo "<p><strong>Etape 4</strong>. Vous allez maintenant interdire l'accès à la catégorie 'espace administrateurs' pour le groupe 'Communauté'. Pour cela, cliquez sur l'icône 'éditer les permissions' de ce groupe et rendez la catégorie visée invisible. Par mesure de sécurité, interdisez également la possibilité d'y ajouter un document.</p>";
    echo "<br/>";
    echo "<p><strong>Conclusion</strong>. La catégorie 'espace administrateurs' est désormais invisible pour tous les utilisateurs existants et à venir. Je vous rappelle que tous les utilisateurs sont automatiquement enregistrés dans le groupe 'Communauté' s'ils ne sont pas inscrits dans un autre groupe.</p>";
    echo "<br/>";
    echo "<p><strong>Remarque :</strong> Un utilisateur peut appartenir à plusieurs groupes. Plus il sera inscrit à des groupes, plus il sera soumis à des restrictions de lecture et d'écriture. La configuration actuelle permet un contrôle d'accès basique et facilement paramétrable. Néanmoins, si vous avez besoin de créer plusieurs couches de restrictions, vous serez obligés de multiplier les groupes ce qui entrainera pour vous une maintenance délicate.</p>";
    echo "<br/>";

    if (!$IE6) {
        echo "</div><br/>";
    }
    if (!$IE6) {
        echo("<div class=\"fond\">
		    <div class=\"coingh\"></div>
            <div class=\"coindh\"></div>
            <div class=\"partiecentralehaut\"></div>
            <div class=\"droite\"></div>
            <div class=\"gauche\"></div>
            <div class=\"coingb\"></div>
		    <div class=\"coindb\"></div>
		    <div class=\"partiecentralebas\"></div>\n");
    }
    echo "<h3>Gestion des droits : Experts</h3>";
    echo "<p>Par défaut, nous l'avons déjà dit précédemment, toutes les catégories et sous-catégories sont accessibles à tous les membres de la communauté à moins de les inscrire dans des groupes de restriction. Cette configuration a l'avantage d'être souple d'utilisation puisqu'elle est très faiblement contraignante pour l'administrateur GEPI. On peut néanmoins inverser la logique en jouant la carte de la prudence. Vous pouvez en effet par défaut, interdire l'accès à toutes les catégories et sous-catégories existantes et à venir. Dans cette nouvelle configuration, les groupes que vous créez deviennent des groupes d'autorisation d'accès.</p>";
    echo "<br/>";
    echo "<p><strong>Modifier les restrictions de base : </strong>Pour changer cette politique de restriction, il suffit de le spécifier en allant dans 'Gestion des groupes' et en cochant l'item 'Interdire toutes les catégories et sous-catégories par défaut'. Dès que vous faites ce choix, toute la logique de restriction est inversée. Petite mise en garde : Ceci signifie que si vous aviez créé des groupes de restrictions sur certaines catégories, ils se transforment en groupes d'autorisations sur ces mêmes catégories.</p>";
    echo "<br/>";
    echo "<p><strong>Etape 1 : </strong>Revenons sur notre exemple précédent. Vous disposez de deux catégories 'Mes Documents' et 'espace administrateurs'. Pour cette dernière, vous voulez la restreindre aux seuls administrateurs GEPI. Par défaut, ces deux catégories sont interdites à tous les utilisateurs. Ce qu'il faut faire dans un premier temps, c'est autoriser l'accès en lecture et en écriture à la catégorie 'Mes Documents' pour le groupe 'Communauté'.</p>";
    echo "<br/>";
    echo "<p><strong>Etape 2 : </strong>Il faut ensuite autoriser en lecture et en écriture la catégorie 'espace administrateurs' pour le groupe 'administrateurs GEPI'.</p>";
    echo "<br/>";
    echo "<p><strong>Etape 3 : </strong>Il suffit enfin d'inscrire les administrateurs GEPI dans le groupe 'administrateurs GEPI'. Les admins sont donc désormais inscrits dans les deux groupes. </p>";
    echo "<br/>";
    echo "<p><strong>Remarque : </strong>Dans ce genre de configuration, plus un utilisateur est inscrit dans des groupes, plus il a d'accès. Ceci permet un contrôle très strict des accès aux catégories. Cette rigueur entraine quelques petites lourdeurs pour les administrateurs. Si vous créez une nouvelle catégorie, vous ne pouvez pas la voir dans un premier temps puisqu'elle est interdite par défaut. Vous devez obligatoirement jouer sur les permissions des groupes pour la faire apparaître et pour pouvoir y insérer des ressources. </p>";
    echo "<br/>";
    if (!$IE6) {
        echo "</div><br/>";
    }
}
else {
    echo "<div class=\"cadreInformation\">Vous tentez d'accéder à une page reservée aux administrateurs</div>";
}
echo "</div>";





?>